//#include <p18f4550.h>
#include <p18f4620.h>
#include <portb.h>
#include <PCF8563.h>
#include <PCF8574.h>
#define LCD_DEFAULT
#include <LCD_44780.h>
#include <intEEPROM.h>
#include <delay.h>

#include <i2cEEPROM.h>
#include <string.h>
#include <usart.h>

// mette la variabile DataX nel banco dati udata1 anzich udata0
# pragma udata udata1
unsigned char DataX [100];
unsigned char DataX0 [150];

//******************************************************
# pragma udata udata2
//*****************************************VARIABILI PER GESTIONE MODULO GSM
unsigned char TestoSms [160];
static char FlagPrimoCarattere;
static char FlagBufferOn;
unsigned char NonUsato;
unsigned char FlagLCD =0;
unsigned char FlagGsmOn =0;
unsigned char RispostaOk=0; 
unsigned char NumSms;
unsigned char NumAbilitatoSquillo[10];
unsigned char NumChiamante[10];
unsigned char NumSmsTecnici[10];
unsigned char DataXOld;
unsigned char TimOut;
unsigned char CarOk=10;
unsigned char CarOld=13;
unsigned char a;
unsigned char r = 0;
unsigned char r2 = 0;
unsigned char RipCicloMorto = 0;
unsigned char r9 = 0;
unsigned char FlagRicSMS=0;
unsigned char FlagMelodiaSquillo =0;
unsigned char FlagSuonSquilloAttiva =0;
unsigned char FlagPassSms =0;
unsigned char FlagRichiestaCredito =0;
unsigned char FlagSmsLancette =0;
unsigned char F = 0;
unsigned char NumSquilli =0;
unsigned char TipoGestore =0 ; // 1=telecom   2=vodafone
unsigned char ErroreGsm=0;
unsigned char PassSms[4];
unsigned char Cifra;
unsigned char TestoSMS[10];
char Stringa[10];
unsigned char Orario[9];
// ***********************FINE VARIABILI PER GSM
//*******************************************************
//imposta nuovamente udata0 come memoria di default per variabili
# pragma udata udata0  
#pragma config OSC = HS 	
#pragma config WDT = OFF 	
#pragma config LVP = OFF 	
#pragma config PBADEN = OFF // imposta tutti gli ingrssi come digitali e non analogici

#define Cicalino LATCbits.LATC0
#define LuceLCD LATCbits.LATC2
#define CampanaA LATEbits.LATE0
#define CampanaB LATEbits.LATE1
#define CampanaC LATEbits.LATE2
#define KeyGsmOn LATCbits.LATC1

unsigned char OutAllarme=0;
// VARIABILI PER LCD
unsigned char lcdXpos=0; // posizione colonna attuale
unsigned char lcdYpos=0; // posizione riga attuale
#define MAX_X 16 // numero di colonne del display
#define MAX_Y 2 // numero di righe del display


unsigned char pippo;
unsigned char byte1;
unsigned char byte2;
// VARIABILI PER GESTIONE CAMPANE
unsigned char ContCampana[3] ;
unsigned char ww ;
unsigned char Campana[3];

// VARIBILI PER DATA E ORA
unsigned char anno ;
unsigned char mese ;
unsigned char giorno ;
unsigned char GiornoSettimana;
unsigned char Ore ;
unsigned char OreScadSquillo;
unsigned char Minuti;
unsigned char Secondi;
unsigned char FlagCambioOraOk =0;
unsigned char FlagGiornoFestivo =0;// 0=feriale   1=Festivo 
unsigned char FlagDisabilitaCampane =0; // se 1 non suonano le campane
unsigned char FlagSettimanaPasquale =0;
unsigned char GiornoLCD[]= {'DOM.','LUN.','MAR.','MER.','GIO.','VEN.','SAB.','DOM.'};

short long TotaleSecondi = 0 ;
//***********************************************************************************
// VARIABILI PER TASTIERA A MATRICE 
unsigned char lettura_PCF8574 ;
unsigned char errore_lettura_PCF8574;
unsigned char data ;

// VARIABILI PER AVANZAMENTO MOTORE PASSO PASSO
unsigned int PassiDaFare;
unsigned int PassiFatti;
unsigned int MaxPassiCiclo;
unsigned int FermaDopo;
unsigned int RaddFino;
unsigned int PassiDaSuoneria =0;
unsigned char flagprimavolta = 0;
unsigned int TotaleSecondi12ore =0 ;
short long TotaleSecondiLancette =0;
unsigned char NumeroPasso = 0 ;
int ContrProxMinuti ;
unsigned char ContrProxOre;
unsigned char FlagProxOre = 0 ;
unsigned char FlagContrProx ;
unsigned char Passo[] =
{
0b000100,
0b010000,
0b001000,
0b100000,
};

// Array per scansione colonne
unsigned char colMask[]=
	{
	0b11101111, // Colonna 1 => RB4 a massa
	0b11011111, // Colonna 2 => RB5 a massa
	0b11110111, // Colonna 3 => RB2 a massa
	0b10111111  // Colonna 4 => RB6 a massa
	};
unsigned char colMask_I2C[]=
	{
	0b01111111, // Colonna 1 => RB4 a massa
	0b10111111, // Colonna 2 => RB5 a massa
	0b11011111, // Colonna 3 => RB2 a massa
	0b11101111  // Colonna 4 => RB6 a massa
	};

unsigned char colScan=0; // va da 0 a 3 per scansionare l'array colMask


// Array per scansione righe
unsigned char rowMask[]=
	{
	0b00001110, // Riga 1
	0b00001101, // Riga 2
	0b00001011, // Riga 3
	0b00000111 // Riga 4
	};
unsigned char rowScan=0;
unsigned char rowVal =0b00000000;

// Array con simboli tastiera
unsigned char keys[]={1,4,7,'*',2,5,8,0,3,6,9,'#','A','B','C','D'};
unsigned char TastoPremuto;
unsigned char keypressed=0; // peso numerico del pulsante premuto
unsigned char bitkeyok; // flag di pulsante premuto
unsigned char TastieraBloccata =1;

//************************************** FUNZIONI
unsigned char ControllaTastiera (void);
unsigned char ControllaTastiera_I2C (void);
unsigned char ImmettiCodiceSetup(void);
unsigned char Setup(void);
unsigned char AggiornaSuonerie(void);
unsigned char SetupOrario(unsigned char); 
unsigned char Beep (int,unsigned char);
unsigned char SetupData(void);
unsigned char VariaCodice(unsigned char);
unsigned char Avanza_lancette(void) ;
unsigned char Avanza_Lancette_Setup(void) ;
unsigned char Vai_a_punto_zero(void);
unsigned char CambiaVariabile(unsigned char,int,int,int);
unsigned char EseguiSuoneria(unsigned char);
unsigned char EseguiSuoneriaSquillo (void);
unsigned char ScriviEeprom (void);
unsigned char LeggiVolt (void);
unsigned char GestioneErrori (unsigned char);
unsigned char AggiornaVariabili (void);
unsigned char VariaNumSmsTecnici(void);
unsigned char Avanza8Passi(void);
unsigned char ControllaGiornoFestivo (void);
//****************FUNZIONI PER GESTIONE MODULO GSM
unsigned char VerificaGsmOnOff(void);
unsigned char ImpostaGsm (void);
unsigned char InviaSms(unsigned char,unsigned char);
unsigned char AzzeraDataX (unsigned char,unsigned char);
unsigned char GestioneSMS (void);
unsigned char GestioneSquilli (void);
unsigned char AttendiRispostaUSART (unsigned char );
unsigned char ComponiStringaGsm (unsigned char, unsigned char);
int Confronta(char*,const rom char*);
unsigned char ConfrontaDataX(char,const rom char*);
unsigned char RichiediCredito (void);
unsigned char ComponiMelodie (void);

unsigned char x=0;
unsigned char x0=0;



	unsigned char time[9];
unsigned char timeold = '0';
	unsigned char value;
//  ALTRE VARIABILI
unsigned char i;
unsigned char CombinazioneSetup [4];
short long TempoScaduto ;
unsigned char TastoOld ;
unsigned char data;
unsigned char FlagCorrAutLanc = 0;
unsigned char FlagSmsCorrLanc ;
unsigned int PassiCorrAvLanc =0;
unsigned int PassiCorrRitLanc =0;
unsigned char FlagPuntoZero ;
unsigned char FlagOrario;
unsigned char FlagInvioSMS;
unsigned char FlagGsm=0;
unsigned char FlagBeep= 0;
unsigned char ContLCD ;
unsigned char Suonerie [10][5];
int VoltAlimentatore;
int VoltBatteria;
int lettura ;
int VoltAlimBassa;
int VoltBattBassa;
int VoltBattScarica;
unsigned char Errore[10];
unsigned char SmsErrore[10];
unsigned char FlagLancSuZero ;
unsigned char TipoSuonoMorto='M';// M=maschio  F=femmina
//************************************************************
// Dichiarazione Prototipi di funzione
//************************************************************
// Prototipo di funzione per bassa priorita'
void Low_Int_Event (void);		

// Prototipo di funzione per alta priorita'
void High_Int_Event (void);	
#pragma code	
void inizializzaPeriferiche (void);


//*************************************************
//               Gestione Interrupt Alta Priorit
//*************************************************

// Prototipo di funzione
void High_Int_Event (void); 


#pragma code high_vector=0x08

void high_interrupt (void) {
	
	// Imposta il salto per la gestione dell'interrupt
	_asm GOTO High_Int_Event _endasm 
}

#pragma code
#pragma interrupt High_Int_Event
void High_Int_Event (void) {
	// Controllo che l'interrupt sia stato generato dall'USART
	if (PIR1bits.RCIF == 1 ) {
if (FlagBufferOn==0){
  DataXOld = DataX[x-1];
	// Leggo il dato dal buffer di ricezione
  	DataX[x] = ReadUSART(); 
  if (DataXOld ==CarOld & DataX[x]==CarOk){
  if (x>3){ // esclude avanzamento riga (13 + 10)inviato dal
          // modulo gsm prima del comando 
 FlagBufferOn=1;
x0=0;
}
} 
x++ ;
}else{
DataX0[x0] = ReadUSART();
x0++;
}
 		PIR1bits.RCIF = 0;
 	}
}


//************************************************************
// Impostazione e Gestione priorita' bassa 
//************************************************************

#pragma code low_vector = 0x18

void low_interrupt (void) {

	// Salto per la gestione dell'interrupt a bassa priorita'
  _asm GOTO Low_Int_Event _endasm 
}

#pragma code

#pragma interruptlow Low_Int_Event

// Funzione per la gestione dell'interruzione a bassa priorita'
void Low_Int_Event (void) {	

// CARICO 49911 
TMR0H =11000010 ;
TMR0L =11110111 ;


// Controllo che l'interrupt sia stato generato da Timer0 
if (INTCONbits.TMR0IF == 1 ) {
//Campana[0] = CampanaA;
//Campana[1] = CampanaB;
//Campana[2] = CampanaC;
if (CampanaA== 1){
ContCampana[0] ++;
}
if (CampanaB== 1){
ContCampana[1] ++;
}
if (CampanaC== 1){
ContCampana[2] ++;
}
for (ww=0 ;ww<3;ww++){
if (ContCampana[ww]>3){  // durata eccitazione magnete battito campane
ContCampana[ww] = 0;
switch (ww){
case 0:
CampanaA = 0;
break;
case 1:
CampanaB = 0;
break;
case 2:
CampanaC = 0;

}
}
}
}

		// Resetto il flag d'interrupt per permettere nuove interruzioni
 		INTCONbits.TMR0IF = 0; 
 	}








//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//X   **********************************************************     X
//X            INIZIO PROGRAMMA PRINCIPALE                           X
//X   **********************************************************     X
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void main (void){

short long TotaleSecondiOld =0 ;
unsigned char NumeroRintocchi= 0 ;
unsigned char FlagCambioOra=0;

unsigned char MinutiOld;


int qq ;
EnablePullups();// Abilita i resistori di pull-up sulla PORTB
inizializzaPeriferiche ();
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Inizializza il modulo I2C a 100KHz @20MHz
OpenI2C(MASTER, SLEW_OFF);
SSPADD = 49;
KeyGsmOn =1;
// inizializzo variabili per liee ingresso	
	// Inizializzo la data	
	set_days_RTCC (0x28);
	set_months_RTCC (0x02);
	set_years_RTCC (0x11);
	

	set_hours_RTCC (0x10);
	set_minutes_RTCC (0x52);
	set_seconds_RTCC (0x48);






set_day_of_the_week_RTCC (0x00);

PCF8574_write_data (0x70, 0b00000011);
errore_lettura_PCF8574 = PCF8574_read_data (0x70, &data);
lettura_PCF8574 = data;

ContrProxOre = 0;
ContrProxMinuti = 0;
for (x=0; x< 11;x++){
Errore[x] = 0;
SmsErrore[x] = 0;
} 	 	


LuceLCD = 1;
ContLCD = 0;
// Inizializzo il display LCD con quarzo a 20MHz

OpenLCD (20);
ClearLCD ( );


WriteStringLCD ("  CAMPANILE DI");
Line2LCD();
WriteStringLCD ("  .....   ");
delay_ms (1500);
ClearLCD();
WriteStringLCD ("     RENATO");
Line2LCD();
WriteStringLCD ("   03/11/2012");
delay_ms (1500);
BacklightLCD (TURN_ON);
writeI2C_EEPROM (0xA0,8,0);// disabilita suoneria 0 
delay_ms(10);
	// Inizializzo l'ora
AggiornaVariabili();

// APRE LA PORTA USART
 	OpenUSART( USART_TX_INT_OFF &
 	USART_RX_INT_ON&
 	USART_ASYNCH_MODE &
 	USART_EIGHT_BIT &
 	USART_CONT_RX &
 	USART_BRGH_HIGH,
    129);  // 10 = 115.200   129= 9600
x=0;
 
RCSTAbits.RX9D = 1;
//************************************ 		
// PER MODULO GSM
if (FlagGsm == 1){
VerificaGsmOnOff();
ImpostaGsm();
}

AzzeraDataX(13,10);
ClearLCD();
WriteStringLCD("GSM IN ATTESA");
FlagBufferOn=0;	 	

if (FlagOrario == 1){
SetupOrario(1);
SetupData();
}

//********************************FINE AVVIO PROGRAMMA
//*******************************************************************
 	while (1){
HomeLCD ();
WriteVarLCD ( get_date_RTCC ());

WriteStringLCD(" ");

GiornoSettimana = EERandomRead (WRITE_ADD,DAY_WEEK_ADDR);  
GiornoSettimana  = GiornoSettimana & 0b00000111;
	
switch (GiornoSettimana) {
case 1:
WriteStringLCD ("LUN.");
break;
case 2:
WriteStringLCD ("MAR.");
break;
case 3:
WriteStringLCD ("MER.");
break;
case 4:
WriteStringLCD ("GIO.");
break;
case 5:
WriteStringLCD ("VEN.");
break;
case 6:
WriteStringLCD ("SAB.");
break;
case 0:
WriteStringLCD ("DOM.");
}

	value = get_hours_RTCC();	
	
	// with +48 I convert the number in ASCII number
	time[1] = (value & 0b00001111)+48; 
	time[0] = (value >> 4)+48;
   Ore = (value & 0b00001111) + ((value >> 4)*10) ;

	value = get_minutes_RTCC();	
	time[4] = (value & 0b00001111)+48;
	time[3] = (value >> 4)+48;
Minuti = (value & 0b00001111) + ((value >> 4)*10) ;	
//	time[5] = ':';

	value = get_seconds_RTCC();	
	time[7] = (value & 0b00001111)+48;
	time[6] = (value >> 4)+48;
Secondi = (value & 0b00001111) + ((value >> 4)*10) ;
if (Secondi==0){
// rilegge i minuti in quanto se  i secondi sono zero
// puo' darsi che siano cambiati i minuti nel tempo che intercorre
// tra la lettura minti e secondi
	value = get_hours_RTCC();	
	time[1] = (value & 0b00001111)+48; 
	time[0] = (value >> 4)+48;
Ore = (value & 0b00001111) + ((value >> 4)*10) ;
value = get_minutes_RTCC();	
	time[4] = (value & 0b00001111)+48;
	time[3] = (value >> 4)+48;
Minuti = (value & 0b00001111) + ((value >> 4)*10) ;	
}
if (Ore == OreScadSquillo){
FlagMelodiaSquillo =0;

}
TotaleSecondi = (float)Ore *3600;
TotaleSecondi =((float) Minuti * 60) + TotaleSecondi ;
TotaleSecondi = (float)Secondi + TotaleSecondi;
	
	time[8] = '\0';
if (flagprimavolta == 0){
MinutiOld = Minuti ;
// aggiorna impostazioni suonerie
AggiornaSuonerie();



if (FlagPuntoZero == 1){
Vai_a_punto_zero();

if (Errore[6]| Errore[3] | Errore[4]){
TotaleSecondiLancette = TotaleSecondi ;
}else{
TotaleSecondiLancette = 0;
}
}else {
TotaleSecondiLancette = TotaleSecondi ;
}



if (TotaleSecondiLancette >= 43200){
TotaleSecondiLancette =(TotaleSecondiLancette - 43200) ;
}
flagprimavolta = 1 ;
}
//return (time);

// effettua ciclo se cambiata l'unit di secondi

//*********************CONTROLLO MODULO GSM (USART)
if (RCSTAbits.OERR){
Beep (100,3);
ClearLCD();
WriteStringLCD("ERRORE USART GSM");
Line2LCD();
WriteStringLCD("BUFFER OVERFLOW!");
delay_ms (2500);
RCSTAbits.CREN =0;
RCSTAbits.CREN =1;
}
//  ************ CONTROLLA SE E' IL BUFFER USART E' CARICO
if (FlagBufferOn==1){
if (ConfrontaDataX(2,(const rom char*)"+CMTI")==0){
GestioneSMS();
}
//   **********CONTROLLA SE E' IN ARRIVO UNA CHIAMATA ED ESEGUE PROGRAMMA CHIAMATE
if (ConfrontaDataX(2,(const rom char*)"RING")==0){
delay_ms(100);
for (r=0;r<100;r++){
DataX[r]=DataX0[r];
}
if (ConfrontaDataX(2,(const rom char*)"+CLIP")==0){
GestioneSquilli();
}
}
AzzeraDataX (13,10); 
FlagBufferOn== 0;
} 	
//************FINE CONTROLLO GSM




if (!(time[7] == timeold)){
// ESEGUE QUESTO CICLO OGNI SECONDO
if (time[5] == ' '){
time[5]= ':' ;
time[2] = ':';
//Cicalino = 0;
} else{
time[2] = ' ';
time[5] = ' ';
}



if (TotaleSecondiOld > TotaleSecondi){
TotaleSecondiOld = TotaleSecondiOld - 86400 ; // 86400 = 24*3600
}
if (TotaleSecondi >= (TotaleSecondiOld +10)){// aggiorna ogni 10 secondi (9+1)
// OGNI 10 SEC. ESEGUE QUESTE FUNZIONI
if (Errore[2]== 0){  // AVANZA LANCETTE SE LA BATTERIA NON E' SCARICA
Avanza_lancette() ;
}
LeggiVolt();
GestioneErrori(0);

if (LuceLCD == 1){
ContLCD ++ ;
}
if (ContLCD > 2){
LuceLCD = 0;
TastieraBloccata = 1;
}
TotaleSecondiOld = TotaleSecondi;
}

//*************Controlla se  attivata la Settimana Pasquale
// CONTROLLO SETTIMANA PASQUALE
if (Ore == 0 & Minuti ==15 & FlagSettimanaPasquale ==1){
if (GiornoSettimana == 2){   // se martedi disattiva la settimana pasquale
FlagSettimanaPasquale == 0;
}
if (GiornoSettimana == 5 ){ // se venerd disattiva le campane
FlagDisabilitaCampane = 1;
}
if (GiornoSettimana == 0 ){ // se domenica attiva le campane
FlagDisabilitaCampane = 0;
}

}

//*************Controlla per cambio  ora legale-solare
// CAMBIO ORA LEGALE-SOLARE
if (Ore > 3){   // azzera flag cambio ora gi avvenuto
FlagCambioOraOk =0;
}
if (Ore==1 & Minuti==15 & GiornoSettimana ==0 & FlagCambioOraOk ==0){
value = get_months_RTCC();	
mese = (value & 0b00001111) + ((value >> 4)*10) ;	
value = get_days_RTCC();	
giorno = (value & 0b00001111) + ((value >> 4)*10) ;	

if (mese==3 & giorno>24){
set_hours_RTCC (0x02);
}
if(mese==10 & giorno >23 & FlagCambioOraOk == 0){
set_hours_RTCC (0x00);
Vai_a_punto_zero();
if(Errore[6]=00 & Errore[3]==0 & Errore[4]==0){
TotaleSecondiLancette = 0;
}
}
FlagCambioOraOk = 1;
}




//********* Rintocchi per cambio ora
// CONTROLLA CAMBIO ORA
//if (Secondi==0 & Minuti==0){
if (Secondi==0 & ((Minuti == 0)|(Minuti == 2))){ 

NumeroRintocchi = Ore;
if (NumeroRintocchi > 12){
NumeroRintocchi = (NumeroRintocchi -12);
}

if (NumeroRintocchi == 0){NumeroRintocchi = 12;
}
}
// CONTROLLA LE MEZZE ORE
if (Secondi == 0 & Minuti == 30){ 
NumeroRintocchi = 1;
} 


if (NumeroRintocchi > 0){
ClearLCD();
HomeLCD();
LuceLCD = 1;
WriteStringLCD("SUONA RINTOCCHI");

while (NumeroRintocchi > 0){
Line2LCD();
WriteIntLCD(NumeroRintocchi,2);
delay_ms(100);
if (FlagDisabilitaCampane ==0){
if (Minuti== 2){
CampanaC = 1 ;
} else {
CampanaA = 1;
}
}
Beep (100,1);
NumeroRintocchi --;
delay_ms (1000);
}
delay_ms (1000);
ClearLCD();
delay_ms (2000);

}

Line2LCD();
WriteStringLCD("");
WriteVarLCD (time);
//WriteStringLCD (" ");

//WriteVarLCD (get_time_seconds_RTCC ());
timeold = time[7];
}
// OGNI MINUTO  CONTROLLA LE SUONERIE 
if (!(MinutiOld == Minuti)){
for (qq=0 ; qq<10 ;qq++){
if ((Suonerie[qq][0] == Ore) & (Suonerie[qq][1]== Minuti)&(Suonerie[qq][4]== 1)){
// CONTROLLA SE E' IL GIORNO IN CUI SUONARE
ControllaGiornoFestivo();
// Suoneria [x][3]   1= Feriale     2=Festivo   3= Ogni giorno
if (((FlagGiornoFestivo==1)& (Suonerie[qq][3]==2))|((FlagGiornoFestivo == 0)&(Suonerie[qq][3]==1))|(Suonerie[qq][3]==3)){

ClearLCD();
LuceLCD = 1 ;

if (qq==0){  //    ESEGUE SUONERIA   SUONO MORTO PROGRAMMATO DA GSM
WriteStringLCD("SUONO MORTO ");
Line2LCD();
if (TipoSuonoMorto == 'M'){
WriteStringLCD("MASCHIO");
RipCicloMorto = 2;
}else{
WriteStringLCD("FEMMINA");
RipCicloMorto = 1;
}
EseguiSuoneria(Suonerie[qq][2]);
for (r2=0;r2<RipCicloMorto;r2++){
for (r9=0;r9<31;r9++){
delay_ms (1000);
if ((r9==10)|(r9==20)){
Avanza8Passi();
}
Beep (100,1);
}
Avanza8Passi();
Avanza8Passi();
EseguiSuoneria(Suonerie[qq][2]);
}
Suonerie[0][4]=0;// suoneria disabilitata
writeI2C_EEPROM (0xA0,8,0);// disabilita suoneria 0 
delay_ms(10);

}else{  //      ESEGUE SUONERIA  (NON SUONO MORTO DA GSM)
WriteStringLCD("SUONERIA N:");
WriteIntLCD ((qq),1);
Line2LCD();
WriteStringLCD("MELODIA: ");
WriteIntLCD (Suonerie[qq][2],1);
EseguiSuoneria(Suonerie[qq][2]);
}
} 
}
}


MinutiOld = Minuti;
}





// controlla se viene premuto un tasto della tastiera

TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto == 99)){
LuceLCD =1 ;
ContLCD = 0;


if (TastieraBloccata == 1){
// la tastiera  bloccata
ClearLCD();
WriteStringLCD("   TASTIERA  ");
Line2LCD();
WriteStringLCD("   BLOCCATA !  ");
delay_ms (500);
ClearLCD();

if (TastoPremuto== 35){
//  premuto #
delay_ms (100);
TastoPremuto = ControllaTastiera_I2C();
if (TastoPremuto == 35){
Beep (100,1);
TastieraBloccata = 0;
HomeLCD();
WriteStringLCD("   TASTIERA   ");
Line2LCD();
WriteStringLCD("   SBLOCCATA  ");
delay_ms (500);
ClearLCD();
}
}

} else {
// La tastiera  sbloccata
if ((TastoPremuto >= 0) & (TastoPremuto < 10)){
if (ImmettiCodiceSetup()== 1){
Beep (100,1);
ClearLCD();
HomeLCD ();
Setup();
}
}else {
// non  premuto un numero ma una lettera
switch (TastoPremuto){
case 'A':
CampanaA = 1;
break;
case 'B':
CampanaB = 1;
break;
case 'C':
CampanaC = 1;
break;
case 'D':
ClearLCD();
HomeLCD();
WriteStringLCD("ESEGUI MELODIA ");
Line2LCD();
WriteStringLCD("NUMERO: ");
CursorLCD(1,1);
while (TastoPremuto == 'D'){
TastoPremuto = ControllaTastiera_I2C();
//ATTENDE SI RILASCI IL TASTO
}
while (TastoPremuto == 99){
TastoPremuto = ControllaTastiera_I2C();
//ATTENDE SI RILASCI IL TASTO
}

if ((TastoPremuto > 0) & (TastoPremuto < 10)){
Beep(100,1);
ClearLCD();
HomeLCD();
WriteStringLCD(" PREMI UN TASTO ");
Line2LCD();
WriteStringLCD("PER FERMARE MEL");
WriteIntLCD(TastoPremuto,1);


EseguiSuoneria(TastoPremuto);
}
CursorLCD(0,0);




ClearLCD();
HomeLCD();

TastoPremuto = '*';
}
TastoOld = TastoPremuto;
while (TastoOld == ControllaTastiera_I2C()){
//ATTENDE SI RILASCI IL TASTO
}
}
}
}
}
}


//**********************************************************************
//**********************************************************************
//**                                                                  **
//**                    INIZIO FUNZIONI                               **
//**                                                                  **
//**********************************************************************
//**********************************************************************

//**************************************************************************************************************
//    CONTROLLA TASTIERA  non usata (in questo pogramma  usato :CONTROLLA TASTIERA IE2)
//**************************************************************************************************************
unsigned char ControllaTastiera (void){
bitkeyok =0;

for (colScan=0; colScan<4; colScan++){ // porto a massa una colonna alla volta
PORTB = colMask[colScan]; // porto a zero la colonna attualePer ogni colonna posta a zero mi effettuo quindi un ciclo di scansione delle 4 righe pi o meno allo stesso modo:
   


// mi controllo le righe
for (rowScan=0; rowScan<4; rowScan++){
keypressed = 0;
rowVal = (PORTA & 0b00001111);//controlla solo i prime 4 bit della porta
if (rowVal == rowMask[rowScan]){ // Riga rowScan trovata a massa
//ritardo per evitare il rimbalzo 
delay_ms (20);
rowVal = (PORTA & 0b00001111);
if (rowVal == rowMask[rowScan]){
keypressed =(rowScan +(4*colScan)); // numero di pulsante premuto
bitkeyok=1; //  stato premuto un pulsante
if (bitkeyok ==1){

// Attende il rilascio del pulsante
//while (rowVal == (PORTA & 0b00001111)){
//}
bitkeyok =0;
//keypressed = 0;
return (keys[keypressed]);

}
}
}


}
}
return (99);
}

//**************************************************************************************************************
//    CONTROLLA TASTIERA I2C
//**************************************************************************************************************
unsigned char ControllaTastiera_I2C (void){
bitkeyok =0;

//PCF8574_write_data (0x70, 0b00000011);
//errore_lettura_PCF8574 = PCF8574_read_data (0x70, &data);
//lettura_PCF8574 = data;



for (colScan=0; colScan<4; colScan++){ // porto a massa una colonna alla volta
//PORTB = colMask[colScan]; // porto a zero la colonna attualePer ogni colonna posta a zero mi effettuo quindi un ciclo di scansione delle 4 righe pi o meno allo stesso modo:
PCF8574_write_data (0x70, colMask_I2C[colScan]);
errore_lettura_PCF8574 = PCF8574_read_data (0x70, &data);
rowVal = (data & 0b00001111);

// mi controllo le righe
for (rowScan=0; rowScan<4; rowScan++){
keypressed = 0;
//rowVal = (PORTA & 0b00001111);//controlla solo i prime 4 bit della porta


if (rowVal == rowMask[rowScan]){ // Riga rowScan trovata a massa
//ritardo per evitare il rimbalzo 
//delay_ms (20);
//rowVal = (PORTA & 0b00001111);
if (rowVal == rowMask[rowScan]){
keypressed =(rowScan +(4*colScan)); // numero di pulsante premuto
bitkeyok=1; //  stato premuto un pulsante
if (bitkeyok ==1){

// Attende il rilascio del pulsante
//while (rowVal == (PORTA & 0b00001111)){
//}
bitkeyok =0;
//keypressed = 0;
return (keys[keypressed]);

}
}
}


}
}
return (99);
}


//**************************************************************************************************************
//    CONTROLLA INGRESSO SETUP
//**************************************************************************************************************
// ritorna 0 se combinazione sbagliata
// ritorna 1 se combinazione ok
// La combinazione di fabbrica  di 5 numeri 9 9 9 9 1
// La combinazione utente  di 4 numeri
unsigned char ImmettiCodiceSetup (void){
unsigned char NumeroCifre ;


unsigned char CombFabbrica []={9,9,9,9,1};
unsigned char FlagCombinazioneOk = 1 ;
unsigned char TastiPremuti[4];
unsigned char r ;
unsigned char FlagCombFabbrica = 1;



ClearLCD();
HomeLCD ();
WriteStringLCD ("IMMETTI CODICE");
Line2LCD ();
WriteIntLCD (TastoPremuto,2);
TastoOld = TastoPremuto ;

TastiPremuti[0]= TastoPremuto;

while (TastoOld == ControllaTastiera_I2C()){
//ATTENDE SI RILASCI IL TASTO
}
TempoScaduto = 0;
for (NumeroCifre = 1 ; NumeroCifre < 4 ;NumeroCifre++) {
TastoPremuto = 99;
while (TastoPremuto >9 ){
TempoScaduto ++;
if (TempoScaduto > 30000){
return(0);
}
TastoPremuto = ControllaTastiera_I2C();
}
TastiPremuti[NumeroCifre]= TastoPremuto;
TempoScaduto =0;
WriteIntLCD (TastoPremuto,2);
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
}



for (r= 0 ; r<4 ; r++){
if (!(TastiPremuti[r] == CombinazioneSetup[r])){
FlagCombinazioneOk = 0;
}
}
if (FlagCombinazioneOk == 1){
return(1);
}

HomeLCD ();

WriteStringLCD (" CODICE ERRATO ");
for (r= 0 ; r<4 ; r++){
if (!(TastiPremuti[r] == CombFabbrica[r])){
FlagCombFabbrica = 0 ;
}
}
if (FlagCombFabbrica == 0){
delay_ms (1000);
return (0);
}
// SE SI E' QUI E' PERCHE LA COMBINAZIONE E' SBAGLIATA MA
// I PRIMI 4 NUMERI DELLA COMBINAZIONE DI FABBRICA SONO OK
TempoScaduto = 0;
TastoPremuto = 99;
while (TastoPremuto >9 ){
TempoScaduto ++;
if (TempoScaduto > 10000){
return(0);
}
TastoPremuto = ControllaTastiera_I2C();
}
if (TastoPremuto == CombFabbrica[4]){

return(1);
} 
return(0);
}

//**************************************************************************************************************
//     SETUP
//**************************************************************************************************************
// richiama la funzione desiderata
// tasto 'D' menu precedente
// tasto 'A' menu successivo
// tasto '#' entra nel menu desiderato
// tasto '*' esce dalla funzione setup
// TempoScaduto  tempo massimo senza premere un pulsante

unsigned char Setup (void){
unsigned char VoceMenu = 1 ;
unsigned char PrimoMenu = 1;
unsigned char UltimoMenu = 30;
unsigned char VoceMenuOld = 0;

ClearLCD();
HomeLCD ();

TastoPremuto = 99;
TempoScaduto = 0;
while (TempoScaduto < 80000 ){

// se VoceMenu  Cambiata scrivi su LCD
if (!(VoceMenuOld == VoceMenu)){
VoceMenuOld = VoceMenu ;
ClearLCD ();
HomeLCD ();
switch (VoceMenu){
case 1:
WriteStringLCD ("CAMBIA ORARIO");
break;
case 2:
WriteStringLCD ("CAMBIA DATA");
break;
case 3:
WriteStringLCD ("AVANZA LANCETTE");
break;
case 4:
WriteStringLCD ("IMPOSTA SUONERIE");
break;
case 5:
WriteStringLCD (" CAMBIA NUMERO");
Line2LCD();
WriteStringLCD ("INVIO SMS TECNICI");
break;
case 6:
WriteStringLCD (" CAMBIA CODICE");
Line2LCD();
WriteStringLCD ("COMANDI CON SMS");
break;

case 7:
WriteStringLCD (" CICALINO");
Line2LCD();
WriteStringLCD (" ABILITATO :");
if (FlagBeep == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 8:
WriteStringLCD ("CAMBIA CODICE");
Line2LCD();
WriteStringLCD ("INGRESSO SETUP");
break;
case 9:
WriteStringLCD ("INVIO SMS LANC.");
Line2LCD();
WriteStringLCD (" ABILITATO :");
if (FlagSmsLancette == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}

break;
case 10:
WriteStringLCD ("   RICHIEDI");
Line2LCD();
WriteStringLCD (" CREDITO SIM");
break;
case 11:
WriteStringLCD ("VAI A PUNTO ZERO");
Line2LCD();
WriteStringLCD ("AVVIO CICLO:");
if (FlagPuntoZero == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 12:
WriteStringLCD ("RICHIEDI ORARIO");
Line2LCD();
WriteStringLCD ("AVVIO CICLO:");
if (FlagOrario == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 13:
WriteStringLCD ("CICLO PASSI");
Line2LCD();
WriteIntLCD(MaxPassiCiclo,4);
break;
case 14:
WriteStringLCD ("FERMA_DOPO");
Line2LCD();
WriteIntLCD(FermaDopo,4);

break;
case 15:
WriteStringLCD ("RADDOPPIA FINO");
Line2LCD();
WriteIntLCD(RaddFino,4);
break;

case 16:
WriteStringLCD ("VOLT ALIM. BASSA");
Line2LCD();
WriteIntLCD ((VoltAlimBassa/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltAlimBassa%10),1);

break;
case 17:
WriteStringLCD ("VOLT BATT. BASSA");
Line2LCD();
WriteIntLCD ((VoltBattBassa/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltBattBassa%10),1);


break;
case 18:
WriteStringLCD ("VOLT BATT.SCARICA");
Line2LCD();
WriteIntLCD ((VoltBattScarica/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltBattScarica%10),1);

break;
case 19:
LeggiVolt();
WriteStringLCD ("VOLT ALIM.: ");
WriteIntLCD ((VoltAlimentatore/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltAlimentatore%10),1);
Line2LCD();
WriteStringLCD ("VOLT BATT.: ");
WriteIntLCD (VoltBatteria/10,2);
WriteStringLCD (",");
WriteIntLCD ((VoltBatteria%10),1);
break;
case 20:
WriteStringLCD ("CONTROLLA PROX");
Line2LCD();
if (FlagContrProx == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 21:
WriteStringLCD ("MODULO GSM");
Line2LCD();
WriteStringLCD ("PRESENTE :");
if (FlagGsm == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 22:
WriteStringLCD (" INVIO SMS");
Line2LCD();
WriteStringLCD (" ABILITATO :");
if (FlagInvioSMS == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 23:
WriteStringLCD (" SCRIVI EEPROOM");
Line2LCD();
WriteStringLCD ("  ");
break;
case 24:
WriteStringLCD ("  SINCRONIZZA");
Line2LCD();
WriteStringLCD ("    LANCETTE");
break;
case 25:
WriteStringLCD ("RESET GENERALE");
break;
case 26:
WriteStringLCD ("COMPONI MELODIE");
break;
case 27:
WriteStringLCD ("CORR.AUT.LANCETTE");
Line2LCD();
WriteStringLCD (" ABILITATO :");
if (FlagCorrAutLanc == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}

break;
case 28:
WriteStringLCD ("SMS CORR. LANC.");
Line2LCD();
WriteStringLCD (" ABILITATO :");
if (FlagSmsCorrLanc == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 29:
WriteStringLCD ("non utilizzato");
break;
case 30:
WriteStringLCD ("30 non utilizz.");
break;

}
}
TempoScaduto ++;
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
}

switch (TastoPremuto) {
case 'A':
VoceMenu ++ ;
if (VoceMenu > UltimoMenu){
VoceMenu = PrimoMenu;
}
TempoScaduto = 0;
break;
case 'D':
TempoScaduto = 0;
VoceMenu --;
if (VoceMenu < PrimoMenu){
VoceMenu = UltimoMenu ;
}
break;
case '*':
ClearLCD();
HomeLCD ();
return(0);
break;
case '#':
// IN BASE ALLA VOCE MENU RICHIAMA LA FUNZIONE DESIDERATA
switch (VoceMenu){
case 1:
SetupOrario(1);
ClearLCD();
return(0);
VoceMenuOld = 0;
break;
case 2:
SetupData();
ClearLCD();
return(0);
break;
case 3:
Avanza_Lancette_Setup();
ClearLCD();
return(0);
break;
case 4:
SetupOrario(10);
return(0);
break;
case 5:
VariaNumSmsTecnici();
return(0);
break;
case 6:
VariaCodice(1);// 1 = varia codice sms
ClearLCD();
return(0);
break;
case 7:
if (FlagBeep == 0){
writeI2C_EEPROM (0xA0, 1006, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1006, 0x00);
}
delay_ms (10);
readI2C_EEPROM (0xA0, 1006, &FlagBeep);
ClearLCD();
WriteStringLCD ("CICALINO");
Line2LCD();
WriteStringLCD ("ABILITATO :");
if (FlagBeep == 1){
WriteStringLCD (" SI");
} else {

WriteStringLCD (" NO");
}
break;
case 8:
//WriteStringLCD (" menu 8");
VariaCodice(0);
ClearLCD();
return(0);
break;
case 9:
if (FlagSmsLancette == 0){
writeI2C_EEPROM (0xA0, 1007, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1007, 0x00);
}
delay_ms (10);
readI2C_EEPROM (0xA0, 1007, &FlagSmsLancette);
ClearLCD();
WriteStringLCD ("INVIO SMS LANC.");
Line2LCD();
WriteStringLCD ("ABILITATO :");
if (FlagSmsLancette == 1){
WriteStringLCD (" SI");
} else {

WriteStringLCD (" NO");
}
break;
case 10:
InviaSms(99,2);//richiede credito
FlagRichiestaCredito =1;
return(0);
break;
case 11:
if (FlagPuntoZero == 0){
writeI2C_EEPROM (0xA0, 1001, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1001, 0x00);
}
// Aspetto che il dato sia propriamente scritto in EEPROM
delay_ms (10);
readI2C_EEPROM (0xA0, 1001, &FlagPuntoZero);
ClearLCD();
WriteStringLCD ("VAI A PUNTO ZERO");
Line2LCD();
WriteStringLCD ("AVVIO CICLO:");
if (FlagPuntoZero == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 12:
if (FlagOrario == 0){
writeI2C_EEPROM (0xA0, 1002, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1002, 0x00);
}
// Aspetto che il dato sia propriamente scritto in EEPROM
delay_ms (10);
readI2C_EEPROM (0xA0, 1002, &FlagOrario);
ClearLCD();
WriteStringLCD ("RICHIEDI ORARIO");
Line2LCD();
WriteStringLCD ("AVVIO CICLO:");
if (FlagOrario == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}

break;
case 13:
CambiaVariabile(4,1010,MaxPassiCiclo,2000);
ClearLCD();
return(0);
break;
case 14:
CambiaVariabile(4,1012,FermaDopo,2000);
ClearLCD();
return(0);
break;
case 15:
CambiaVariabile(4,1014,RaddFino,2000);
ClearLCD();
return(0);
break;
case 16:
CambiaVariabile(4,1016,VoltAlimBassa,200);
ClearLCD();
return(0);
break;
case 17:
CambiaVariabile(4,1018,VoltBattBassa,200);
ClearLCD();
return(0);
break;
case 18:
CambiaVariabile(4,1020,VoltBattScarica,140);
ClearLCD();
return(0);
break;
case 19:
break;
case 20:
if (FlagContrProx == 0){
writeI2C_EEPROM (0xA0, 1003, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1003, 0x00);
Errore[3]=0;
Errore[4]=0;
Errore[6]=0;
}
// Aspetto che il dato sia propriamente scritto in EEPROM
delay_ms (10);
readI2C_EEPROM (0xA0, 1003, &FlagContrProx);
ClearLCD();
WriteStringLCD ("CONTROLLA PROX");
Line2LCD();
if (FlagContrProx == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 21:
if (FlagGsm == 0){
writeI2C_EEPROM (0xA0, 1004, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1004, 0x00);
}
// Aspetto che il dato sia propriamente scritto in EEPROM
delay_ms (10);
readI2C_EEPROM (0xA0, 1004, &FlagGsm);
delay_ms (10);
ClearLCD();
WriteStringLCD ("MODULO GSM");
Line2LCD();
WriteStringLCD ("PRESENTE :");
if (FlagGsm == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 22:
if (FlagInvioSMS == 0){
writeI2C_EEPROM (0xA0, 1005, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1005, 0x00);
}
delay_ms (10);
readI2C_EEPROM (0xA0, 1005, &FlagInvioSMS);
ClearLCD();
WriteStringLCD ("INVIO SMS");
Line2LCD();
WriteStringLCD ("ABILITATO :");
if (FlagInvioSMS == 1){
WriteStringLCD (" SI");
} else {

WriteStringLCD (" NO");
}

break;
case 23:
ScriviEeprom();
ClearLCD();
return(0);
break;

case 24:
Vai_a_punto_zero();
if(Errore[6]=00 & Errore[3]==0 & Errore[4]==0){
TotaleSecondiLancette = 0;
}
return(0);
break;
case 25:
Reset();
break;
case 26:
ComponiMelodie();
return(0);
break;
case 27:
if (FlagCorrAutLanc == 0){
writeI2C_EEPROM (0xA0, 1008, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1008, 0x00);
}
delay_ms (10);
readI2C_EEPROM (0xA0, 1008, &FlagCorrAutLanc);
ClearLCD();
WriteStringLCD ("CORR.AUT.LANCETTE");
Line2LCD();
WriteStringLCD ("ABILITATO :");
if (FlagCorrAutLanc == 1){
WriteStringLCD (" SI");
} else {

WriteStringLCD (" NO");
}
break;

case 28:
if (FlagSmsCorrLanc == 0){
writeI2C_EEPROM (0xA0, 1009, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1009, 0x00);
}
delay_ms (10);
readI2C_EEPROM (0xA0, 1009, &FlagSmsCorrLanc);
ClearLCD();
WriteStringLCD ("SMS CORR. LANC.");
Line2LCD();
WriteStringLCD ("ABILITATO :");
if (FlagSmsCorrLanc == 1){
WriteStringLCD (" SI");
} else {
WriteStringLCD (" NO");
}
break;
case 29:

break;
case 30:

break;





}
break;
} 
}
TempoScaduto = 0;
}

//***************************************
//    SETUP ORARIO
//**************************************
unsigned char SetupOrario (unsigned char TipoOrario) {
// Tipo Orario :
// 1 = Orario Orologio
// 10 = imposta suoneria
unsigned char q ;
unsigned char TimeNext[9] ;
unsigned char MaxValTimeNext []= {2,9,6,9,6,9} ;
unsigned char NumTimeNext = 0 ;
unsigned char SpostCursLCD = 4 ;

TempoScaduto = 0;
Beep (100,1);
ClearLCD ();
HomeLCD ();
CursorLCD (1,1);
if (TipoOrario == 1){
value = get_hours_RTCC();
TimeNext[1] = (value & 0b00001111); 
TimeNext[0] = (value >> 4);
value = get_minutes_RTCC();
TimeNext[3] = (value & 0b00001111); 
TimeNext[2] = (value >> 4);
value = get_seconds_RTCC();
TimeNext[5] = (value & 0b00001111); 
TimeNext[4] = (value >> 4);
WriteStringLCD ("NUOVO ORARIO") ;
}else{

// RICHIEDI NUMERO SUONERA .... DA 0 A 9
WriteStringLCD ("NUMERO SUONERIA:");
Line2LCD();

//WriteStringLCD ("");
if (TipoOrario>2){
TipoOrario = 0;
}
WriteIntLCD (TipoOrario,1);
ShiftCursorLCD (0,1);
TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '#')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto >= 0)& (TastoPremuto < 10)){
TipoOrario = TastoPremuto ;
WriteIntLCD (TipoOrario,1);
Line2LCD();
}else{
Beep (20,1);
}
}
}
TipoOrario = (TipoOrario *10);
ClearLCD ();
HomeLCD ();

// CARICA ORARIO DA EEPROM
for (q=0 ; q<10;q++){
readI2C_EEPROM (0xA0, (TipoOrario+q), &TimeNext[q]);
}

WriteStringLCD ("SUONERIA:");
WriteIntLCD ((TipoOrario/10),1);
WriteStringLCD (" MEL:");
WriteIntLCD (TimeNext[6],1);
Line2LCD ();
if (TimeNext[8]== 1){
WriteStringLCD ("         ON ");
}else{
WriteStringLCD ("         OFF");
}
switch (TimeNext[7]){
case 1:
WriteStringLCD(" FER");
break;
case 2:
WriteStringLCD(" FES");
break;
case 3:
WriteStringLCD(" 7gg");

}
}


//WriteVarLCD (get_time_seconds_RTCC ());
Line2LCD() ;
WriteIntLCD (TimeNext[0],1);
WriteIntLCD (TimeNext [1],1);
WriteStringLCD (":");
WriteIntLCD (TimeNext[2],1);
WriteIntLCD (TimeNext[3],1);
WriteStringLCD (":");
WriteIntLCD (TimeNext[4],1);
WriteIntLCD (TimeNext[5],1);



TastoPremuto = 99;
TempoScaduto = 0;

Line2LCD();
//ShiftCursorLCD (1,SpostCursLCD);

while (TempoScaduto < 300000 ){

TempoScaduto ++;
TastoPremuto = ControllaTastiera_I2C();

if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}


switch (TastoPremuto) {

case '*':
Beep (100,1);
ClearLCD();
HomeLCD ();
Beep (100,3);
CursorLCD (0,0);
return(0);
break;
case '#':
if (TipoOrario== 1){
set_hours_RTCC ((TimeNext[0] << 4)+ TimeNext[1]);
set_minutes_RTCC ((TimeNext[2] << 4)+ TimeNext[3]);
set_seconds_RTCC ((TimeNext[4] << 4)+ TimeNext[5]);
} else {

// richiedi tipo suoneria

ClearLCD();
Beep (100,1);
WriteStringLCD ("ABBINA MELODIA:");
Line2LCD();
//WriteStringLCD ("");
WriteIntLCD (TimeNext[6],1);

ShiftCursorLCD (0,1);
TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '#')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto >=0)& (TastoPremuto < 10)){
TimeNext[6] = TastoPremuto ;
WriteIntLCD (TimeNext[6],1);
Line2LCD();
}else{
Beep (20,1);
}
}
}

// RICHIEDI GIORNO IN CUI SUONARE

ClearLCD();
Beep (100,1);
WriteStringLCD ("QUANDO SUONO ?");
Line2LCD();
//WriteStringLCD ("");
WriteIntLCD (TimeNext[7],1);
switch (TimeNext[7]){
case 1:
WriteStringLCD (" FERIALE    ");
break;
case 2:
WriteStringLCD (" FESTIVO    ");
break;
case 3:
WriteStringLCD (" OGNI GIORNO");
break;
default :
WriteStringLCD (" premi 1-2-3");
}
Line2LCD();

TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '#')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto >=1)& (TastoPremuto < 4)){
TimeNext[7] = TastoPremuto ;
WriteIntLCD (TimeNext[7],1);

switch (TimeNext[7]){
case 1:
WriteStringLCD (" FERIALE    ");
break;
case 2:
WriteStringLCD (" FESTIVO    ");
break;
case 3:
WriteStringLCD (" OGNI GIORNO");
break;
}
Line2LCD();
}else{
Beep (20,1);
}
}
}




// richiedi SE SUONERIA ON/OFF

ClearLCD();
Beep (100,1);
WriteStringLCD ("STATO SUONERIA:");
Line2LCD();
//WriteStringLCD ("");
WriteIntLCD (TimeNext[8],1);
switch (TimeNext[8]) {
break;
case 0:
WriteStringLCD (" OFF         ");
break;
case 1:
WriteStringLCD (" ON          ");
break;
default :
WriteStringLCD (" DA DEFINIRE ");
}

ShiftCursorLCD (0,14);
TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '#')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto == 0)| (TastoPremuto == 1)){
TimeNext[8] = TastoPremuto ;
WriteIntLCD (TimeNext[8],1);
switch (TimeNext[8]) {
case 0:
WriteStringLCD (" OFF ");
break;
case 1:
WriteStringLCD (" ON  ");
break ;

}
Line2LCD();
}else{
Beep (20,1);
}
}
}

for (q=0 ;q<9 ;q++){
writeI2C_EEPROM (0xA0,(TipoOrario+q), TimeNext[q]);
delay_ms(10);
}
AggiornaSuonerie();

}
CursorLCD (0,0);
Beep (100,3);
return(0);
break ;
}
if ((TastoPremuto >=0)& (TastoPremuto < 10)){
switch (NumTimeNext) {
case 0:// controlla e imposta decine ore
if (TastoPremuto > 2) {
Beep (100,2);
}else {
TimeNext[0] = TastoPremuto ;
NumTimeNext =1;
SpostCursLCD = 1;
}
break ;
case 1:// imposta unita' ore
if ((TimeNext[0] == 2) & TastoPremuto >3){
Beep(100,2);
} else {
TimeNext[1] = TastoPremuto ;
NumTimeNext = 2;
SpostCursLCD = 3 ;
}
break;
case 2 : // imposta decine minuti
if (TastoPremuto > 5) {
Beep (100,2);
}else {
TimeNext[2] = TastoPremuto ;
NumTimeNext =3;
SpostCursLCD = 4;
}
break ;// controlla e imposta unita' minuti
case 3 :
TimeNext[3] = TastoPremuto ;
NumTimeNext =4;
SpostCursLCD = 6;
break;
case 4 : // controlla e imposta decine secondi
if (TastoPremuto > 5) {
Beep (100,2);
}else {
TimeNext[4] = TastoPremuto ;
NumTimeNext =5;
SpostCursLCD = 7;
}
break ;
case 5 : //controlla e imposta unita secondi
TimeNext[5] = TastoPremuto ;
NumTimeNext =0;
SpostCursLCD = 0;
break;
}
}
Line2LCD() ;
//WriteStringLCD ("    ");
WriteIntLCD (TimeNext[0],1);
WriteIntLCD (TimeNext [1],1);
WriteStringLCD (":");
WriteIntLCD (TimeNext[2],1);
WriteIntLCD (TimeNext[3],1);
WriteStringLCD (":");
WriteIntLCD (TimeNext[4],1);
WriteIntLCD (TimeNext[5],1);
Line2LCD() ;
ShiftCursorLCD (1,SpostCursLCD);
}
} 
ClearLCD();
HomeLCD ();
CursorLCD (0,0);
Beep (100,1);
TempoScaduto = 0;
}

//***************************************
//    SETUP DATA
//**************************************
unsigned char SetupData (void) {
unsigned char DataNext[6] ;
unsigned char MaxValDataNext []= {31,29,31,30,31,30,31,31,30,31,30,31} ;
unsigned char NumDataNext = 0 ;
unsigned char SpostCursLCD = 4 ;
unsigned char RestoAnniBis ; 
unsigned char Anno;
TempoScaduto = 0;
Beep (100,1);

ClearLCD();
HomeLCD ();

	value = get_days_RTCC();	
	
	DataNext[1] = (value & 0b00001111); 
	DataNext[0] = (value >> 4);
			
	value = get_months_RTCC();	
	DataNext[3] = (value & 0b00001111);
	DataNext[2] = (value >> 4);
		value = get_years_RTCC();	
	DataNext[5] = (value & 0b00001111);
	DataNext[4] = (value >> 4);
	
	


HomeLCD ();
WriteStringLCD (" INSERIRE DATA") ;
Line2LCD() ;
WriteStringLCD ("    ");
WriteIntLCD (DataNext[0],1);
WriteIntLCD (DataNext [1],1);
WriteStringLCD ("/");
WriteIntLCD (DataNext[2],1);
WriteIntLCD (DataNext[3],1);
WriteStringLCD ("/");
WriteIntLCD (DataNext[4],1);
WriteIntLCD (DataNext[5],1);
TastoPremuto = 99;
TempoScaduto = 0;
CursorLCD (1,1);
Line2LCD();
ShiftCursorLCD (1,SpostCursLCD);
while (TempoScaduto < 300000 ){

TempoScaduto ++;
TastoPremuto = ControllaTastiera_I2C();

if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}


switch (TastoPremuto) {

case '*':
Beep (100,1);
ClearLCD();
HomeLCD ();
Beep (100,3);
CursorLCD (0,0);
return(0);
break;
case '#':
if (NumDataNext > 0 ){
Beep (100,3);
ClearLCD();
WriteStringLCD ("   TERMINARE ");
Line2LCD();
WriteStringLCD ("  INSERIMENTO ");
Beep (100,3);
delay_ms (1000);
ClearLCD();
WriteStringLCD ("  NUOVA DATA") ;
Line2LCD() ;
TastoPremuto = 98;
}else {
ClearLCD();
Beep (100,1);

GiornoSettimana = EERandomRead (WRITE_ADD,DAY_WEEK_ADDR);  
GiornoSettimana  = GiornoSettimana & 0b00000111;
if (GiornoSettimana == 0){
GiornoSettimana = 7;
}
WriteStringLCD ("GIORNO SETTIMANA :");
Line2LCD();
WriteStringLCD ("      ");
WriteIntLCD (GiornoSettimana,1);
switch (GiornoSettimana) {
case 1:
WriteStringLCD (" LUN.");
break;
case 2:
WriteStringLCD (" MAR.");
break;
case 3:
WriteStringLCD (" MER.");
break;
case 4:
WriteStringLCD (" GIO.");
break;
case 5:
WriteStringLCD (" VEN.");
break;
case 6:
WriteStringLCD (" SAB.");
break;
case 7:
WriteStringLCD (" DOM.");
}
ShiftCursorLCD (0,6);
TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '#')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto >0)& (TastoPremuto < 8)){
GiornoSettimana = TastoPremuto ;
WriteIntLCD (GiornoSettimana,1);
switch (GiornoSettimana) {
case 1:
WriteStringLCD (" LUN.");
break;
case 2:
WriteStringLCD (" MAR.");
break;
case 3:
WriteStringLCD (" MER.");
break;
case 4:
WriteStringLCD (" GIO.");
break;
case 5:
WriteStringLCD (" VEN.");
break;
case 6:
WriteStringLCD (" SAB.");
break;
case 7:
WriteStringLCD (" DOM.");
}
ShiftCursorLCD (0,6);
}
}
}
if (GiornoSettimana ==7){
GiornoSettimana = 0;
}
set_day_of_the_week_RTCC (GiornoSettimana);
set_days_RTCC ((DataNext[0] << 4)+ DataNext[1]);
set_months_RTCC ((DataNext[2] << 4)+ DataNext[3]);
set_years_RTCC ((DataNext[4] << 4)+ DataNext[5]);
CursorLCD (0,0);
return(0);
}
break ;
}
if ((TastoPremuto >=0)& (TastoPremuto < 10)){
switch (NumDataNext) {
case 0:// controlla e imposta decine giorni
if (TastoPremuto > 3) {
Beep (100,2);
}else {
DataNext[0] = TastoPremuto ;
NumDataNext =1;
SpostCursLCD = 5;
}
break ;
case 1:// imposta unita' giorni
if ((DataNext[0] == 3) & TastoPremuto >1){
Beep(100,2);
} else {
DataNext[1] = TastoPremuto ;
NumDataNext = 2;
SpostCursLCD = 7 ;
}
break;
case 2 : // imposta decine mesi
if (TastoPremuto > 1) {
Beep (100,2);
}else {
DataNext[2] = TastoPremuto ;
NumDataNext =3;
SpostCursLCD = 8;
}
break ;// controlla e imposta unita' mesi
case 3 :

if ((DataNext[2] == 1 & TastoPremuto >2) | (DataNext[2]==0 & TastoPremuto == 0)){
Beep(100,2);
break;
} 
// CONTROLLA NON SIA INSERITO FEBBRAIO CON 30 GG
if (DataNext[0] == 3 & DataNext[1] == 0 & DataNext[2] == 0 & TastoPremuto == 2){
Beep (100,2);
break;
}
// CONTROLLA I MESI CON 30 GG
if (DataNext[0] == 3 & DataNext[1] == 1){
if (TastoPremuto == 4 |  TastoPremuto == 6 | TastoPremuto == 9 | TastoPremuto == 11){
Beep (100,2);
break;
}
}
DataNext[3] = TastoPremuto ;
NumDataNext = 4;
SpostCursLCD = 10 ;

break;





case 4 : // controlla e imposta decine anni
DataNext[4] = TastoPremuto ;
NumDataNext =5;
SpostCursLCD = 11;
break ;
case 5 : //controlla e imposta unita anni
if (DataNext[2] == 0 & DataNext[3] == 2 & DataNext [0] == 2 & DataNext[1] ==9){
Anno = (DataNext[4]*10)+ TastoPremuto ;
RestoAnniBis =  Anno % 4 ;
if (RestoAnniBis > 0){
Beep (100,2);
break;
}

}


DataNext[5] = TastoPremuto ;
NumDataNext =0;
SpostCursLCD = 4;
break;
}
}
Line2LCD() ;
WriteStringLCD ("    ");
WriteIntLCD (DataNext[0],1);
WriteIntLCD (DataNext [1],1);
WriteStringLCD ("/");
WriteIntLCD (DataNext[2],1);
WriteIntLCD (DataNext[3],1);
WriteStringLCD ("/");
WriteIntLCD (DataNext[4],1);
WriteIntLCD (DataNext[5],1);
Line2LCD() ;
ShiftCursorLCD (1,SpostCursLCD);
}
} 
ClearLCD();
HomeLCD ();
CursorLCD (0,0);
Beep (100,1);
TempoScaduto = 0;
}

//***************************************
//    VARIA CODICE ACCESSO SETUP O CODICE SMS
//**************************************
unsigned char VariaCodice(unsigned char TipoCodice) {
// TipoCodice   0= setup   1=Codice comandi sms
unsigned char Serie[8];
unsigned char NumImmesso=0 ;
unsigned char n ;
Beep (100,1);
ClearLCD ();
HomeLCD ();
switch (TipoCodice) {
case 0:
WriteStringLCD ("CODICE SETUP");
Line2LCD ();
WriteStringLCD ("          ");
for(n=0;n<4;n++){
WriteIntLCD(CombinazioneSetup[n],1);
}
break;
case 1:
WriteStringLCD ("CODICE COM. SMS");
Line2LCD ();
WriteStringLCD ("          ");
for(n=0;n<4;n++){
WriteIntLCD((PassSms[n]-48),1);
}
break;
}
Line2LCD ();
CursorLCD(1,1);
while (TempoScaduto < 50000 ){

TempoScaduto ++;
TastoPremuto = ControllaTastiera_I2C();

if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto >=0)& (TastoPremuto < 10)){
TempoScaduto = 0;
Serie[NumImmesso] = TastoPremuto ;

WriteIntLCD(Serie[NumImmesso],1);
NumImmesso ++ ;
if (NumImmesso == 4){
Beep(100,1);
ClearLCD ();
HomeLCD ();
WriteStringLCD ("CONFERMA CODICE");
Line2LCD ();
}
if (NumImmesso == 8){
for (n=0;n<4;n++){
if (!(Serie[n] == Serie[n+4])){
CursorLCD (0,0);
return(0);
}
}
Beep (100,1);
if (TipoCodice==0){
n=10;
}else{
for (n=0;n<4;n++){
Serie[n] = (Serie[n]+48);
}
n=0;
}
writeI2C_EEPROM (0xA0, (1051+n), Serie[0]);
delay_ms (10);
writeI2C_EEPROM (0xA0, (1052+n), Serie[1]);
delay_ms (10);
writeI2C_EEPROM (0xA0, (1053+n), Serie[2]);
delay_ms (10);
writeI2C_EEPROM (0xA0, (1054+n), Serie[3]);
delay_ms (50);
CursorLCD (0,0);
delay_ms (10);
AggiornaVariabili();
return(0);
}
}
}
}
Beep (100,1);
CursorLCD (0,0);
}
//***************************************
//   VARIA NUMERO CELLULARE PER INVIO SMS TECNICI
//**************************************
unsigned char VariaNumSmsTecnici(void){
unsigned char Serie1[11];
unsigned char NumImm=0 ;
unsigned char n1 ;
unsigned char FlagPrimaVolta =1;
Beep (100,1);
ClearLCD ();
HomeLCD ();
WriteStringLCD ("NUM.SMS TECNICI");
Line2LCD ();
for(n1=0;n1<10;n1++){
WriteIntLCD((NumSmsTecnici[n1]-48),1);
}
Line2LCD();
CursorLCD(1,1);

while (TempoScaduto < 50000 ){

TempoScaduto ++;
TastoPremuto = ControllaTastiera_I2C();

if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if (FlagPrimaVolta == 1){
for (n1=0;n1<10;n1++){
Serie1[n1] = 99;
}
FlagPrimaVolta =0;
Line2LCD();
WriteStringLCD("                ");
Line2LCD();
}
if ((TastoPremuto >=0)& (TastoPremuto < 10)){
TempoScaduto = 0;
Serie1[NumImm] = TastoPremuto ;

WriteIntLCD(Serie1[NumImm],1);
NumImm ++ ;
if (NumImm == 10){
Beep(100,1);
NumImm = 0;
Line2LCD ();
}


}

if (TastoPremuto =='#'){
for (n1=0;n1<10;n1++){
if (Serie1[n1] != 99){ // se = 99 non  stato inserito il numero
Serie1[n1] = (Serie1[n1]+48);
}
writeI2C_EEPROM (0xA0, (1070+n1), Serie1[n1]);
delay_ms (10);
}
delay_ms (50);
CursorLCD (0,0);
delay_ms (50);
AggiornaVariabili();
return(0);
}
if (TastoPremuto =='*'){
CursorLCD (0,0);
delay_ms (50);
return(0);
}
}
}


}
//***************************************
//    BEEP
//**************************************
unsigned char Beep (int Durata,unsigned char NumVolte) {
unsigned char a = 0 ;
for (a=0 ;a<NumVolte ; a++){ 
if (FlagBeep==1){
Cicalino = 1 ;
}
delay_ms (Durata);
Cicalino = 0 ;
delay_ms (100);
}
}
//***************************************
//    AVANZA LANCETTE DI 8 PASSI (PER SUONERIE)
//**************************************
unsigned char Avanza8Passi (void){
unsigned char x8;
for( x8=0;x8<8;x8++) {
   PORTA = Passo[NumeroPasso];
   delay_ms (30);
   NumeroPasso++;
   PassiDaSuoneria ++;
    if (NumeroPasso >3 ){
    NumeroPasso = 0;
    }
    }
    PORTA = 0b000000;
}
//***************************************
//    AVANZA LANCETTE
//**************************************
unsigned char Avanza_lancette (void) {
unsigned char RitVel ;
unsigned char Rampa =0 ; 
unsigned char Dacan=0;
unsigned char gg ;
unsigned int PassiLCD ;
unsigned char RestoPassi;
TotaleSecondiLancette = TotaleSecondiLancette + PassiDaSuoneria ;
PassiDaSuoneria = 0;

if(PassiCorrAvLanc >0){  // Avanza lancette del contenuto di PassiCorrAvLanc
if (TotaleSecondiLancette > PassiCorrAvLanc){
TotaleSecondiLancette = TotaleSecondiLancette - PassiCorrAvLanc;
PassiCorrAvLanc =0;
}
}


if (TotaleSecondiLancette >= 43200){
TotaleSecondiLancette =(TotaleSecondiLancette - 43200) ;
}
if (TotaleSecondi >= 43200){ // 43200 = 12*3600
TotaleSecondi12ore = (TotaleSecondi - 43200) ;
} else {
TotaleSecondi12ore = TotaleSecondi;
}
if (TotaleSecondiLancette > TotaleSecondi12ore){
PassiDaFare = (43200 - TotaleSecondiLancette) + TotaleSecondi12ore;
}else{
PassiDaFare =(TotaleSecondi12ore- TotaleSecondiLancette) ;
}

if (PassiCorrRitLanc > 0){ // ritarda lancette del contenuto di PassiCorrRitLanc
if ( PassiCorrRitLanc >= PassiDaFare){
PassiCorrRitLanc = PassiCorrRitLanc - PassiDaFare;
TotaleSecondiLancette = TotaleSecondiLancette + PassiDaFare;
PassiDaFare = 0;
}else{
PassiDaFare = PassiDaFare - PassiCorrRitLanc ;
TotaleSecondiLancette = TotaleSecondiLancette + PassiCorrRitLanc;
PassiCorrRitLanc =0;
}
}



HomeLCD();
ClearLCD();


WriteStringLCD("Avanza lancette");
Line2LCD();
WriteStringLCD (" Passi:     ");
PassiLCD = PassiDaFare;
for (gg=0;gg<5;gg++){
RestoPassi = PassiLCD%10;
PassiLCD = PassiLCD/10;
WriteIntLCD (RestoPassi,1);
ShiftCursorLCD(LEFT,2);
}


if (PassiDaFare > 15) {
// Non controlla posizione corrette lancette
FlagLancSuZero = 1;
}
RitVel = 30;

delay_ms(100);

while (PassiDaFare > 0){
if (PassiFatti > MaxPassiCiclo){
PassiFatti = 0;
}

if(!(PassiFatti > FermaDopo)){

// calcola velocita motore
if (Rampa==0){
if ((PassiDaFare > 200)& (RitVel >3)){
RitVel --;
}
if ((PassiDaFare < 200) & (RitVel < 30)){
RitVel ++;
}
}
Rampa++;
if (Rampa > 4){
Rampa =0;
}
//PORTA = 0b00000000;
//delay_ms (1);
//ShiftCursorLCD (0,5);
//WriteIntLCD (PassiDaFare,5);
PORTA = Passo[NumeroPasso];
delay_ms (RitVel);
NumeroPasso++;


// CONTROLLO PROX LANCETTE se FlagContrProx = 1
if (FlagContrProx == 1){
if (0b00010000 & PORTB){
// prossimity lancetta minuti non attivato 
ContrProxMinuti ++;
}else {
if (ContrProxMinuti > 0){
ContrProxOre ++;
}
ContrProxMinuti =0;
}
if (ContrProxMinuti > 3800){
Errore[3]= 1; // ERRORE PROX MINUTI
}
if(0b00001000 & PORTB){ // lancette ore su prox ore
ContrProxOre = 0;
}
if (ContrProxOre >12) {
Errore[4]=1; // ERRORE PROX ORE
}
}else{
ContrProxMinuti =0;
ContrProxOre =0;
}
if (NumeroPasso >3 ){
NumeroPasso = 0;
}
}
PassiDaFare --;
TotaleSecondiLancette ++;

if (TotaleSecondiLancette >= 43200){
TotaleSecondiLancette =(TotaleSecondiLancette - 43200) ;
}
PassiFatti ++;
}
PORTA = 0b000000;
ClearLCD();

// CONTROLLA POSIZIONE LANCETTE
if ((!(0b00010000 & PORTB))& (FlagLancSuZero == 0)){
// esegue questo ciclo solo una volta ..quando la 
// lancetta minuti attiva il prox Minuti  
FlagLancSuZero = 1;
if ((Ore == 13 & Minuti > 30)| (Ore == 14 & Minuti < 30)){
if (FlagSmsLancette ==1){
InviaSms(27,1);
}
}
//if (!((Minuti == 59)|(Minuti == 0)|(Minuti == 1))){
if ( (Minuti < 58 )&( Minuti > 2)){  // LANCETTE IN errore
Errore [5]++;
}else{
Errore[5]= 0;
if (FlagCorrAutLanc == 1){
PassiCorrRitLanc = 0;
if (Minuti == 58){
PassiCorrRitLanc = 60;
InviaSms (28,1);
}
PassiCorrAvLanc = 0;
if (Minuti == 2){
PassiCorrAvLanc = 60;
InviaSms (28,1);
}
}


}
}
if (0b00010000& PORTB){
FlagLancSuZero = 0;
}


}


//***************************************
//    AVANZA LANCETTE da SETUP
//**************************************
unsigned char Avanza_Lancette_Setup (void) {
Beep (300,1);
HomeLCD();
ClearLCD();
WriteStringLCD("AVANZA LANCETTE");
Line2LCD();
WriteStringLCD ("3:Min 6:Med 9:Max");
TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '*')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
//TastoOld = TastoPremuto ;
//while (TastoOld == ControllaTastiera_I2C()){
//}

if ((TastoPremuto ==3) | (TastoPremuto == 6)|(TastoPremuto == 9)){
PORTA = 0b00000000;
delay_ms(1);
PORTA = Passo[NumeroPasso];
switch(TastoPremuto){ 
case  3:
delay_ms (200);
break;

case  6:
delay_ms (20);
break;
case  9:
delay_ms (2);
}

NumeroPasso++;
if (NumeroPasso >3 ){
NumeroPasso = 0;
}

}


}else{
PORTA = 0b000000 ;
}

}
}


//***************************************
//    VAI A PUNTO ZERO (MEZZANOTTE O MEZZOGIORNO) CON LE LANCETTE
//**************************************
unsigned char Vai_a_punto_zero(void) {
unsigned char TimMot= 50;
unsigned char Rallenta= 0 ;
unsigned char ErroreProx;
FlagProxOre = 0;
ContrProxMinuti = 0;
ContrProxOre = 0;
Errore[3] = 0; // Errore prox Minuti
Errore[4] = 0; // Errore prox Ore
Errore[6] =0;
HomeLCD();
ClearLCD();
WriteStringLCD("CERCO PUNTO");
Line2LCD();
WriteStringLCD ("ZERO LANCETTE");
while  (0b00011000 & PORTB){
if (0b00001000 & PORTB){// controlla prox lancette ore
if ((TimMot> 3) &( Rallenta == 0)){
TimMot  --;
}
}else{
if ((Rallenta == 0)& (TimMot < 55)){
TimMot ++;
}

Rallenta ++;
if (Rallenta > 3){
Rallenta = 0;
}
}

PORTA = Passo[NumeroPasso];
delay_ms (TimMot);
NumeroPasso++;
if (!(0b00001000 & PORTB)){
FlagProxOre = 1;
}else{
if (FlagProxOre & (!(0b00010000 & PORTB ))){
// Lancetta gi passata su prox ore e non passato prox minuti insieme
Errore[6] = 1;
Beep (100,3);
ClearLCD();
WriteStringLCD ("PUNTO ZERO NON ");
Line2LCD();
WriteStringLCD ("    TROVATO");
delay_ms(1000);
ClearLCD();
break;
}
}

// CONTROLLO PROX LANCETTE
if (0b00010000 & PORTB){
// prossimity lancetta minuti non attivato 
ContrProxMinuti ++;
}else {
if (ContrProxMinuti > 0){
ContrProxOre ++;
}
ContrProxMinuti =0;
}
if (ContrProxMinuti > 3800){
Errore[3]= 1; // ERRORE PROX MINUTI
}
if (ContrProxOre >12) {
Errore[4]=1; // ERRORE PROX ORE
}
if (Errore[3] | Errore[4]){

Beep (100,3);
ClearLCD();
WriteStringLCD ("PUNTO ZERO NON ");
Line2LCD();
WriteStringLCD ("TROVATO");
delay_ms(1000);
ClearLCD();
break;
}
if (NumeroPasso >3 ){
NumeroPasso = 0;
}
}

PORTA = 0b00000000;
Beep(200,3);
ContrProxOre = 0;
ContrProxMinuti = 0;
TotaleSecondiLancette = 0;
} 

//***************************************
//    CAMBIA VARIABILI
//**************************************
unsigned char CambiaVariabile(unsigned char NumCifre,int NumEeprom,int ValoreIn,int ValoreMax) {
unsigned int Cifra[4] ;
unsigned char NumImm =0;
int ValoreOut=0;
Cifra[0]= ValoreIn/1000;
ValoreIn = ValoreIn - (Cifra[0]*1000);
Cifra[1] = ValoreIn/100;
ValoreIn = ValoreIn -(Cifra[1]*100);
Cifra[2] = ValoreIn/10;
ValoreIn = ValoreIn - (Cifra[2]*10);
Cifra[3] = ValoreIn;

Line2LCD();
WriteIntLCD(Cifra[0],1);
WriteIntLCD(Cifra[1],1);
WriteIntLCD(Cifra[2],1);
WriteIntLCD(Cifra[3],1);
Line2LCD();
CursorLCD(1,1);


while (1){
TastoPremuto = ControllaTastiera_I2C();
if (TastoPremuto == '*'){
CursorLCD(0,0);
return(0);
}
if (TastoPremuto == '#'){
ValoreOut = (Cifra[0]*1000)+(Cifra[1]*100)+(Cifra[2]*10)+Cifra[3];
if (ValoreMax > ValoreOut){

//MaxPassiCiclo= 405;
byte1 = (char)ValoreOut;
byte2 = (char) (ValoreOut >>8);
writeI2C_EEPROM (0xA0, NumEeprom, byte1);
delay_ms (10);
writeI2C_EEPROM (0xA0, (NumEeprom+1), byte2);
delay_ms (10);
AggiornaVariabili();
}else{
Beep(100,3);
HomeLCD();
WriteStringLCD("VALORE NON CORRETTO");
delay_ms(1000);
}



CursorLCD(0,0);
return(0);
}
if  ((NumImm < NumCifre)& (TastoPremuto < 10)& (TastoPremuto  >=0)){
Cifra[NumImm] = TastoPremuto;
WriteIntLCD(TastoPremuto,1);
NumImm ++;
if (NumImm == NumCifre){
CursorLCD(0,0);
WriteStringLCD("*=ESC #=CONF.");
}
}
while (!(TastoPremuto == 99)){
TastoPremuto = ControllaTastiera_I2C();
}
}
}


//***************************************
//   LEGGI VOLT ALIMENTATORE E BATTERIA
//**************************************
unsigned char LeggiVolt(void) {
unsigned char rr ;

// Seleziono AN1 come ingresso
ADCON0 = 0b00000100;
//ADCON0 = 0b00000100;
// Imposto i tempi di conversione e giustificazione a destra
// TAD : FOSC/4
// TACQ: 16 TAD
ADCON2 = 0b10110100;
// Abilito l' ADC
ADCON0bits.ADON = 0x01;

// Leggo AN1 Volt Alimentatore
VoltAlimentatore = 0;
           // Effettuo 32 letture per fare una media
for (rr =0; rr<32; rr++){
          // Avvio la conversione Analogico/Digitale
ADCON0bits.GO = 1;
          // Attendo la fine della conversione
while(ADCON0bits.GO);
         // Prelevo il valore della conversione
lettura = (((int) ADRESH) << 8) | ADRESL;
         // Sommatoria delle letture fatte
VoltAlimentatore = VoltAlimentatore + lettura;
}
 // 5 shift per la media  = DIVIDE PER 32
VoltAlimentatore = VoltAlimentatore >> 5;
VoltAlimentatore = ((VoltAlimentatore *25)/146)+6;// +6  = aggiunge 0,6v. per caduta tensione diodo

// Leggo AN0 Volt Batteria
// Seleziono AN0 come ingresso
ADCON0 = 0b00000000;
ADCON2 = 0b10110100;
// Abilito l' ADC
ADCON0bits.ADON = 0x01;
VoltBatteria = 0;
           // Effettuo 32 letture per fare una media
for (rr =0; rr<32; rr++){
          // Avvio la conversione Analogico/Digitale
ADCON0bits.GO = 1;
          // Attendo la fine della conversione
while(ADCON0bits.GO);
         // Prelevo il valore della conversione
lettura = (((int) ADRESH) << 8) | ADRESL;
         // Sommatoria delle letture fatte
VoltBatteria = VoltBatteria + lettura;
}
 // 5 shift per la media  = DIVIDE PER 32
VoltBatteria = VoltBatteria >> 5;
VoltBatteria = (VoltBatteria / 7)+6 ;

if(VoltAlimentatore < VoltAlimBassa){
Errore[0] ++;
}else{
Errore[0]=0;
}
if(VoltBatteria < VoltBattBassa){
Errore[1] ++;
}else{
Errore[1]= 0;
}
if(VoltBatteria < VoltBattScarica){
Errore[2] ++;
}else{
Errore[2]= 0;
}

}



//***************************************
//    AGGIORNA VARIABILI
//**************************************
unsigned char AggiornaVariabili(void) {
unsigned char a3;
ClearLCD();
WriteStringLCD("AGGIORNO VARIAB.");
// aggiorna MaxPassiCiclo 
readI2C_EEPROM (0xA0, 1010, &byte1);
readI2C_EEPROM (0xA0, 1011, &byte2);
MaxPassiCiclo = byte2;
MaxPassiCiclo= (MaxPassiCiclo << 8);
MaxPassiCiclo =  MaxPassiCiclo + byte1;
if (MaxPassiCiclo >9999 ){
MaxPassiCiclo = 0;
} 
// aggiorna FermaDopo 
readI2C_EEPROM (0xA0, 1012, &byte1);
readI2C_EEPROM (0xA0, 1013, &byte2);
FermaDopo = byte2;
FermaDopo= (FermaDopo << 8);
FermaDopo =  FermaDopo + byte1;
if (FermaDopo >9999 ){
FermaDopo = 0;
}
// aggiorna FRaddFino 
readI2C_EEPROM (0xA0, 1014, &byte1);
readI2C_EEPROM (0xA0, 1015, &byte2);
RaddFino = byte2;
RaddFino= (RaddFino << 8);
RaddFino =  RaddFino + byte1;
if (RaddFino >9999){
RaddFino = 0;
}
// aggiorna Volt Alimentazione Bassa 
readI2C_EEPROM (0xA0, 1016, &byte1);
readI2C_EEPROM (0xA0, 1017, &byte2);
VoltAlimBassa = byte2;
VoltAlimBassa= (VoltAlimBassa << 8);
VoltAlimBassa =  VoltAlimBassa + byte1;
if (VoltAlimBassa < 0){
VoltAlimBassa = 0;
}
// aggiorna Volt Batteria Bassa 
readI2C_EEPROM (0xA0, 1018, &byte1);
readI2C_EEPROM (0xA0, 1019, &byte2);
VoltBattBassa = byte2;
VoltBattBassa= (VoltBattBassa << 8);
VoltBattBassa =  VoltBattBassa + byte1;
if (VoltBattBassa < 0){
VoltBattBassa = 0;
}
// aggiorna Volt Batteria Scarica 
readI2C_EEPROM (0xA0, 1020, &byte1);
readI2C_EEPROM (0xA0, 1021, &byte2);
VoltBattScarica = byte2;
VoltBattScarica= (VoltBattScarica << 8);
VoltBattScarica =  VoltBattScarica + byte1;
if ((VoltBattScarica < 0)|(VoltBattScarica > 9999)){
VoltBattScarica = 0;
}
for (a3=0;a3<4;a3++){
readI2C_EEPROM (0xA0, a3+1051, &Cifra);
delay_ms(100);
PassSms[a3]=Cifra;
}

for (a3=0;a3<4;a3++){
readI2C_EEPROM (0xA0, a3+1061, &Cifra);
delay_ms(100);
CombinazioneSetup[a3]=Cifra;
}
for (a3=0;a3<10;a3++){
readI2C_EEPROM (0xA0, a3+1070, &Cifra);
delay_ms(100);
NumSmsTecnici[a3]=Cifra;
//NumAbilitatoSquillo[a3];// dacan*****************************************
//FlagMelodiaSquillo =3; // dacan****************************************
}
readI2C_EEPROM (0xA0, 1001, &FlagPuntoZero);
delay_ms(20);
readI2C_EEPROM (0xA0, 1002, &FlagOrario);
delay_ms(20);
readI2C_EEPROM (0xA0, 1003, &FlagContrProx);
delay_ms(20);
readI2C_EEPROM (0xA0, 1004, &FlagGsm);
delay_ms (20);
readI2C_EEPROM (0xA0, 1005, &FlagInvioSMS);
delay_ms(20);
readI2C_EEPROM (0xA0, 1006, &FlagBeep);
delay_ms(20);
readI2C_EEPROM (0xA0, 1007, &FlagSmsLancette);
delay_ms(20);
readI2C_EEPROM (0xA0, 1008, &FlagCorrAutLanc);
delay_ms(20);
readI2C_EEPROM (0xA0, 1009, &FlagSmsCorrLanc);
delay_ms(20);
ClearLCD();
}

//***************************************
//    AGGIORNA SUONERIE
//**************************************
unsigned char AggiornaSuonerie(void) {
unsigned char ff;
unsigned char ffn;
unsigned char ffx;
unsigned char Variabile[9] ; 
// IMPOSTAZINE SUONERIE DA 0 A 9
// [0] = ORE
// [1] = MINUTI
// [2] = TIPO SUONERIA   1=festivo   2=feriale
// [3] = 1= ON 0 = OFF
for (ff=0 ;ff< 10 ;ff++){
ffx = (ff*10);

for (ffn = 0 ; ffn<9 ;ffn++){
readI2C_EEPROM (0xA0, (ffx+ffn), &Variabile[ffn]);
}
Suonerie[ff][0] = (Variabile[0]*10)+Variabile[1];// ORA IN CUI SUONARE
Suonerie[ff][1] = (Variabile[2]*10)+Variabile[3];// MINUTI IN CUI SUONARE
Suonerie[ff][2] = Variabile[6]; // NUMERO MELODIA ABBINATA
Suonerie[ff][3] = Variabile[7]; // GIORNO SETTIM IN CUI SUONARE  FER/FEST/TUTTI I GIORNI
Suonerie[ff][4] = Variabile[8]; // esclusione/attivazione suoneria
}

}
//***************************************
//    ESEGUI SUONERIE DA TASTIERA O DA TIMER MELODIE
//**************************************
unsigned char EseguiSuoneria (unsigned char NumSuoneria) {
unsigned char NumCicli ;
unsigned char ValCella ;
unsigned char yy;
unsigned char x7;
unsigned char TastoRilasciato = 0;
int Timer;
int CellaEeprom= (float)NumSuoneria*100;
CampanaA = 0;
CampanaB = 0;
CampanaC = 0;
readI2C_EEPROM (0xA0, (CellaEeprom), &NumCicli);
CellaEeprom ++;
readI2C_EEPROM (0xA0, (CellaEeprom), &ValCella);
for (yy = 0;yy < NumCicli+1;yy++){
while (ValCella < 0xFF){

TastoPremuto = ControllaTastiera_I2C();

switch (ValCella){
case 251:
if(FlagDisabilitaCampane == 0){
CampanaA = 1;
}
break;
case 252:
if(FlagDisabilitaCampane == 0){
CampanaB = 1;
}
break;
case 253:
if(FlagDisabilitaCampane == 0){
CampanaC = 1;
}
break;
case 254:
Avanza8Passi();

}
if (ValCella < 251){
Timer = ValCella;// 
Timer = (Timer * 60);
delay_ms (Timer);
}
CellaEeprom ++;
readI2C_EEPROM (0xA0, (CellaEeprom), &ValCella);
TastoPremuto = ControllaTastiera_I2C();
if (TastoPremuto == 99){
TastoRilasciato = 1;
}
if ((TastoPremuto < 99) & (TastoRilasciato == 1)){
ValCella = 0xFF;
NumCicli = 0;
}
}
CellaEeprom = (((float)NumSuoneria* 100)+1);
readI2C_EEPROM (0xA0, (CellaEeprom), &ValCella);

}

Beep (100,3);

}

//***************************************
//    ESEGUI SUONERIE DA SQUILLO
//**************************************
unsigned char EseguiSuoneriaSquillo (void) {
unsigned char NumCicli=0 ;
unsigned char ValCella ;
unsigned char yy;
unsigned char x7;
unsigned char TastoRilasciato = 0;
int Timer;
int CellaEeprom= (float)FlagMelodiaSquillo*100;
ClearLCD();
HomeLCD();
WriteStringLCD ("ESEGUI SUONERIA");
Line2LCD();
WriteIntLCD(FlagMelodiaSquillo,1);
WriteStringLCD(" DA SQUILLO");
FlagSuonSquilloAttiva =1;
CampanaA = 0;
CampanaB = 0;
CampanaC = 0;
NumCicli=200;
CellaEeprom ++;
readI2C_EEPROM (0xA0, (CellaEeprom), &ValCella);
for (yy = 0;yy < NumCicli;yy++){
  while (ValCella < 0xFF){
  switch (ValCella){
  case 251:
if(FlagDisabilitaCampane == 0){
  CampanaA = 1;
  }
  break;
  case 252:
if(FlagDisabilitaCampane == 0){
  CampanaB = 1;
  } 
 break;
  case 253:
if(FlagDisabilitaCampane == 0){
  CampanaC = 1;
  } 
 break;
  case 254:
   Avanza8Passi();
 }


//  ************ CONTROLLA SE E' IL BUFFER USART E' CARICO
if (FlagBufferOn==1){
//if (ConfrontaDataX(2,(const rom char*)"+CMTI")==0){
//GestioneSMS();
//}
//   **********CONTROLLA SE E' IN ARRIVO UNA CHIAMATA ED ESEGUE PROGRAMMA CHIAMATE
if (ConfrontaDataX(2,(const rom char*)"RING")==0){
delay_ms(100);
for (r=0;r<100;r++){
DataX[r]=DataX0[r];
}
if (ConfrontaDataX(2,(const rom char*)"+CLIP")==0){
GestioneSquilli();
}
}
AzzeraDataX (13,10); 
FlagBufferOn== 0;
} 	




if (ValCella < 251){
Timer = ValCella;// 
Timer = (Timer * 60);
delay_ms (Timer);
}
CellaEeprom ++;
readI2C_EEPROM (0xA0, (CellaEeprom), &ValCella);

if (FlagSuonSquilloAttiva == 2){
yy =NumCicli+1;
ValCella = 0xFF;
}
}
CellaEeprom= (float)FlagMelodiaSquillo*100;

readI2C_EEPROM (0xA0, (CellaEeprom), &ValCella);

}

Beep (100,3);
FlagSuonSquilloAttiva =0;
}
//***************************************
//   GESTIONE  ERRORI
//**************************************
unsigned char GestioneErrori (unsigned char TipoErrore) {
unsigned char tt;
unsigned char ErroreGenerale ;
// errore [0] = volt alimentazione bassa
// errore[1] = volt batteria bassa
// Errore[2] = batteria scarica

if (Errore[0] > 20){  // ERRORE ALIMENTAZIONE BASSA
if (Errore[0] > 200){Errore[0]=200;} 
ClearLCD();
WriteStringLCD("MANCA ALIMENTAZIONE");
Line2LCD();
WriteStringLCD("VOLT: ");
WriteIntLCD ((VoltAlimentatore/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltAlimentatore%10),1);

delay_ms (1000);
if (SmsErrore[0] == 0){
InviaSms(20,1);
SmsErrore[0]= 1;
}
}else{
SmsErrore[0]= 0;
}

if ((Errore[1] > 2)&( SmsErrore[1] == 0)){  // ERRORE BATTERIA  BASSA
if (Errore[1] > 200){Errore[1]=200;} 
ClearLCD();
WriteStringLCD("BATT.QUASI SCAR.");
Line2LCD();
WriteStringLCD("VOLT: ");
WriteIntLCD ((VoltBatteria/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltBatteria%10),1);
delay_ms (1000);
if (SmsErrore[1] == 0){
InviaSms(21,1);
SmsErrore[1]= 1;
}
}



if ((Errore[2] > 2)& (SmsErrore[2]== 0)){  // ERRORE BATTERIA  SCARICA
if (Errore[2] > 200){Errore[2]=200;} 
ClearLCD();
WriteStringLCD("BATTERIA SCARICA");
Line2LCD();
WriteStringLCD("VOLT: ");
WriteIntLCD ((VoltBatteria/10),2);
WriteStringLCD (",");
WriteIntLCD ((VoltBatteria%10),1);
delay_ms (1000);
if (SmsErrore[2] == 0){
InviaSms(22,1);
SmsErrore[2]= 1;
}
}


if (Errore[3] & (SmsErrore[3]== 0)){  // ERRORE prox minuti non trovato
ClearLCD();
WriteStringLCD("PROX MINUTI");
Line2LCD();
WriteStringLCD("NON TROVATO ");
delay_ms (1000);
if (SmsErrore[3] == 0){
InviaSms(23,1);
SmsErrore[3]= 1;
}
}



if (Errore[4] & (SmsErrore[4]== 0)){  // ERRORE prox ORE non trovato
ClearLCD();
WriteStringLCD("   PROX ORE");
Line2LCD();
WriteStringLCD(" NON TROVATO ");
delay_ms (1000);
if (SmsErrore[4] == 0){
InviaSms(24,1);
SmsErrore[4]= 1;
}
}

if ((Errore[5] > 1) & (SmsErrore[5]== 0)){  // ERRORE 
ClearLCD();
WriteStringLCD("POSIZIONE LANCETTE");
Line2LCD();
WriteStringLCD(" NON CORRETTA ");
delay_ms (1000);
if (SmsErrore[5] == 0){
InviaSms(25,1);
SmsErrore[5]= 1;
}
}
if (Errore[6] & (SmsErrore[6]== 0)){  // ERRORE prox ORE non trovato
ClearLCD();
WriteStringLCD("PROX NON POSIZION.");
Line2LCD();
WriteStringLCD("SULLE ORE  12 ");
delay_ms (1000);
if (SmsErrore[6] == 0){
InviaSms(26,1);
SmsErrore[6]= 1;
}
}
ErroreGenerale = 0;
for (tt= 1;tt< 7;tt++){
if ((Errore[tt]== 0)& (SmsErrore[tt]==1)){
SmsErrore[tt]= 0;
}
ErroreGenerale = (ErroreGenerale + SmsErrore[tt]);
}
if (ErroreGenerale == 0){
OutAllarme = 0;
}else{
OutAllarme = 1;
}
ClearLCD();


}



//***************************************
//    SCRIVI EEPROM
//**************************************
unsigned char ScriviEeprom (void) {
// suoneria 1   FESTA
writeI2C_EEPROM (0xA0, 100, 0x03);
delay_ms (10);
writeI2C_EEPROM (0xA0, 101, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 102, 0x04);
delay_ms (10);
writeI2C_EEPROM (0xA0, 103, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 104, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 105, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 106, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 107, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 108, 0x04);
delay_ms (10);
writeI2C_EEPROM (0xA0, 109, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 110, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 111, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 112, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 113, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 114, 0x04);
delay_ms (10);
writeI2C_EEPROM (0xA0, 115, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 116, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 117, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 118, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 119, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 120, 0x04);
delay_ms (10);
writeI2C_EEPROM (0xA0, 121, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 122, 0x04);
delay_ms (10);
writeI2C_EEPROM (0xA0, 123, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 124, 0x04);
delay_ms (10);
writeI2C_EEPROM (0xA0, 125, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 126, 0x08);
delay_ms (10);
writeI2C_EEPROM (0xA0, 127, 0xFF);
delay_ms (10);

//  suoneria 2   ciclico feriale
writeI2C_EEPROM (0xA0, 200, 0x05);
delay_ms (10);
writeI2C_EEPROM (0xA0, 201, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 202, 0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 203, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 204, 0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 205, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 206, 0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 207, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 208, 0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 209, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 210, 0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 211, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 212, 0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 213, 0xFF);
delay_ms (10);

// suoneria 3 suono morto
writeI2C_EEPROM (0xA0, 300,0x03);
delay_ms (10);
writeI2C_EEPROM (0xA0, 301, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 302, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 303, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 304, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 305, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 306, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 307, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 308, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 309, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 310, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 311, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 312, 0xFE);
delay_ms (10);
writeI2C_EEPROM (0xA0, 313, 0xFE);
delay_ms (10);
writeI2C_EEPROM (0xA0, 314, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 315, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 316, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 317, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 318, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 319, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 320, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 321, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 322, 0x32);
delay_ms (10);
writeI2C_EEPROM (0xA0, 323, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 324, 0x26);
delay_ms (10);
writeI2C_EEPROM (0xA0, 325, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 326, 0xFE);
delay_ms (10);
writeI2C_EEPROM (0xA0, 327, 0xFE);
delay_ms (10);
writeI2C_EEPROM (0xA0, 328, 0x26);
delay_ms (10);
writeI2C_EEPROM (0xA0, 329, 0xFF);
delay_ms (10);

// suoneria 4 ciclico festivo
writeI2C_EEPROM (0xA0, 400,0x0A);
delay_ms (10);
writeI2C_EEPROM (0xA0, 401, 0xFD);
delay_ms (10);
writeI2C_EEPROM (0xA0, 402, 0x07);
delay_ms (10);
writeI2C_EEPROM (0xA0, 403, 0xFC);
delay_ms (10);
writeI2C_EEPROM (0xA0, 404, 0x07);
delay_ms (10);
writeI2C_EEPROM (0xA0, 405, 0xFB);
delay_ms (10);
writeI2C_EEPROM (0xA0, 406, 0x07);
delay_ms (10);
writeI2C_EEPROM (0xA0, 407, 0xFF);

}
//***************************************
//    CONTROLLA SE E' UN GIORNO FESTIVO
//**************************************
unsigned char ControllaGiornoFestivo (void){
value = get_months_RTCC();	
mese = (value & 0b00001111) + ((value >> 4)*10) ;	
value = get_days_RTCC();	
giorno = (value & 0b00001111) + ((value >> 4)*10) ;	
FlagGiornoFestivo = 0;
if (FlagSettimanaPasquale == 1 & GiornoSettimana == 1){ //PASQUETTA
FlagGiornoFestivo =1;
}
if (mese==1 & giorno==1){ // CAPODANNO
FlagGiornoFestivo = 1;
}
if (mese==1 & giorno==6){ // EPIFANIA
FlagGiornoFestivo = 1;
}
if (mese==4 & giorno==25){ // 25 APRILE
FlagGiornoFestivo = 1;
}
if (mese==5 & giorno==1){ // PRIMO MAGGIO
FlagGiornoFestivo = 1;
}
if (mese==6 & giorno==2){ // FESTA REPUBBLICA
FlagGiornoFestivo = 1;
}
if (mese==8 & giorno==15){ // FERRAGOSTO
FlagGiornoFestivo = 1;
}
if (mese==12 & giorno==25){ // NATALE
FlagGiornoFestivo = 1;
}
if (mese==12 & giorno==26){ // SANTO STEFANO
FlagGiornoFestivo = 1;
}
if (GiornoSettimana == 0){ // DOMENICA
FlagGiornoFestivo = 1;
}
}

//***************************************
//    COMPONI MELODIE
//**************************************
unsigned char ComponiMelodie (void){
unsigned char NumeroMelodia = 1;
unsigned char ProgressivoCellaMemoria ;
unsigned char ValoreCella ;
unsigned char FlagPrimaVoltaa =1;
int NumeroCella;
unsigned char FlagVariazioneInAtto = 0;
unsigned char NumCifra=0;
unsigned char Centinaia ;
unsigned char Decine;
unsigned char Unita;
ClearLCD();
WriteStringLCD("COMPONI MELODIA");
Line2LCD();
CursorLCD (1,1);
WriteIntLCD (NumeroMelodia,1);
ShiftCursorLCD (0,1);
TastoPremuto = ControllaTastiera_I2C();
while (!(TastoPremuto == '#')){
TastoPremuto = ControllaTastiera_I2C();
if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto > 0)& (TastoPremuto < 10)){
NumeroMelodia = TastoPremuto ;
WriteIntLCD (NumeroMelodia,1);
Line2LCD();
}else{
Beep (20,1);
}
}
}
ProgressivoCellaMemoria = 0;

NumeroCella =(((float) NumeroMelodia) * 100 ) + ProgressivoCellaMemoria;
ClearLCD();
WriteStringLCD("MELODIA ");
WriteIntLCD (NumeroMelodia,1);
CursorLCD (0,0);

while (1){
if (FlagPrimaVoltaa == 1){
TastoPremuto = 'B';
FlagPrimaVoltaa = 0;
} else {
TastoPremuto = ControllaTastiera_I2C();
}




if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if (TastoPremuto == 'A'){

if (ProgressivoCellaMemoria < 99){
ProgressivoCellaMemoria ++;
Beep (100,1);
}
}
if (TastoPremuto == 'D'){
if (ProgressivoCellaMemoria > 0){
ProgressivoCellaMemoria --;
Beep (100,1);

}
}


// INIZIO PROCEDURA PER VARIARE VALORE TRA 1 E 255

if (TastoPremuto == '#'){
FlagVariazioneInAtto = 1;
CursorLCD (1,1);
}



while (FlagVariazioneInAtto == 1){
TastoPremuto = ControllaTastiera_I2C();

if (!(TastoPremuto ==99)){
TastoOld = TastoPremuto ;
while (TastoOld == ControllaTastiera_I2C()){
}
if ((TastoPremuto >=0) & (TastoPremuto < 10)){

switch (NumCifra){
case 0:  // inserimento centinaia
if (TastoPremuto < 3){  // inserimento centinaia
Centinaia = TastoPremuto ;
WriteIntLCD (TastoPremuto,1);
NumCifra ++;
Decine = 0;
Unita = 0;
WriteIntLCD(Decine,1);
WriteIntLCD(Unita,1);
ShiftCursorLCD (0,2);
}else{
Beep (100,3);
}

break;
case 1:                // inserimento Decine
if ((TastoPremuto >=0) & (TastoPremuto < 10)){
if ((Centinaia < 2) | (TastoPremuto < 6 & Centinaia > 1)){
Decine = TastoPremuto ;
WriteIntLCD (TastoPremuto,1);
NumCifra ++;

}else{
Beep (100,3);
}
} 
break;
case 2:                // inserimento Unita
if ((TastoPremuto >=0) & (TastoPremuto < 10)){
if ((Centinaia < 2) | (TastoPremuto < 6 & Decine < 6)){
Unita = TastoPremuto ;
WriteIntLCD (TastoPremuto,1);
ShiftCursorLCD (0,1);


}else{
Beep (100,3);
}
} 
break ;
}

}


if (TastoPremuto == '#'){  //PREMUTO TASTO CONFERMA
FlagVariazioneInAtto = 0;
CursorLCD (0,0);
NumCifra =0;
TastoPremuto = 99;
//ValoreCella = ((float)Centinaia *100)+(float)Decine*10+Unita ;
ValoreCella = (Centinaia *100)+(Decine*10) + Unita ;
writeI2C_EEPROM (0xA0, NumeroCella, ValoreCella);
delay_ms (10);
Beep(100,1);
}


if (TastoPremuto == '*'){   // PREMUTO TASTO ESCAPE
FlagVariazioneInAtto = 0;
CursorLCD (0,0);
TastoPremuto = 99;
Beep (100,3);
}

}
}

// FINE PROCEDURA



if (TastoPremuto == '*'){
return(0);
}



Line2LCD();
WriteStringLCD("PASSO ");
WriteIntLCD (ProgressivoCellaMemoria,2);
WriteStringLCD(" = ");
NumeroCella = ((float)NumeroMelodia*100) + ProgressivoCellaMemoria;
readI2C_EEPROM (0xA0, NumeroCella, &ValoreCella);
delay_ms(20);
Centinaia = ValoreCella/100;
Decine = (ValoreCella-(Centinaia*100))/ 10;
Unita = (ValoreCella-(Centinaia*100))% 10;

WriteIntLCD(Centinaia, 1);
WriteIntLCD(Decine,1);
WriteIntLCD(Unita,1);



ShiftCursorLCD (0,3);

//}
}
}
}



//*************************************************************************
//*************************************************************************
//                                                                       **
//                             DA QUI IN POI FUNZIONI PER MODULO GSM     **
//                                                                       **
//*************************************************************************
//*************************************************************************

//*************************************************************
//               VERIFICA SE IL MODULO E' ACCESO O NO
//*************************************************************
unsigned char VerificaGsmOnOff (void) {
unsigned char ModuloAcceso =0;
char Str_Ready[]="Ready";
unsigned char xx;


ClearLCD();
WriteStringLCD("VERIFICO GSM");
// invio Comando a Modulo se  gia' acceso abilita l'eco dei comandi ed
// apprende la velocit di trasmissione (autobaud)

for (xx=0;xx<2;xx++){
AzzeraDataX(13,10);
putrsUSART((far rom char *)"ATE1\r\n");//ATE0: Eco dei comandi disabilitato
delay_ms(100);
//putrsUSART((far rom char *)"AT+IPR=115200\r\n");//
//delay_ms(200);
AzzeraDataX(13,10);
putrsUSART((far rom char *)"AT\r\n");//ATE0: Eco dei comandi disabilitato
AttendiRispostaUSART(10);
if (ConfrontaDataX(0,(const rom char*)"AT")==0){
ModuloAcceso =1;
ClearLCD();
WriteStringLCD("GSM E' ACCESO");
delay_ms (500);
}else{   
//          ****************    il modulo non  acceso
ClearLCD();
WriteStringLCD("GSM NON RISPONDE");
Line2LCD();
WriteStringLCD("   LO ACCENDO!");
CloseUSART();
delay_ms(100);
OpenUSART( USART_TX_INT_OFF &
 	USART_RX_INT_ON&
 	USART_ASYNCH_MODE &
 	USART_EIGHT_BIT &
 	USART_CONT_RX &
 	USART_BRGH_HIGH,
    10);
KeyGsmOn = 0;// Preme pulsante on/off
delay_ms (1500);
KeyGsmOn = 1;
AzzeraDataX(13,10);
AttendiRispostaUSART(250);
ModuloAcceso =0;
if (ConfrontaDataX(2,(const rom char*)"Call")==0){
ModuloAcceso =1;
}

if (ModuloAcceso ==1){
putrsUSART((far rom char *)"AT+IPR=9600\r\n");//
delay_ms(100);
CloseUSART();
delay_ms(100);
OpenUSART( USART_TX_INT_OFF &
 	USART_RX_INT_ON&
 	USART_ASYNCH_MODE &
 	USART_EIGHT_BIT &
 	USART_CONT_RX &
 	USART_BRGH_HIGH,
    129);
}
}
}
putrsUSART((far rom char *)"ATE0\r\n");//ATE0: Eco dei comandi disabilitato
delay_ms(250);



}

//*************************************************************
//               ATTENDI RISPOSTA BUFFER USART
//*************************************************************
unsigned char AttendiRispostaUSART (unsigned char Tempo){
TimOut = 0;
while ((TimOut < Tempo) & (FlagBufferOn == 0)){
delay_ms(100);
TimOut++;
}
}
//*************************************************************
//               IMPOSTA SETUP MODULO GSM
//*************************************************************
unsigned char ImpostaGsm (void){
unsigned char NumSms;
unsigned char v[2]="1";
unsigned char Segnale;
//putrsUSART((far rom char *)"AT+IPR=9600\r\n");//ATE0: Eco dei comandi disabilitato
//delay_ms(250);
//*******************ATE0: Eco dei comandi disabilitato
AzzeraDataX(13,10);
putrsUSART((const far rom char *)"ATE0\r\n");
AttendiRispostaUSART(10);
if (ConfrontaDataX(2,(const rom char*)"OK")!=0){
ErroreGsm =1;
}
//*********************** abilita ID chiamante
AzzeraDataX(13,10);
putrsUSART((const far rom char *)"AT+CLIP=1\r\n"); 
AttendiRispostaUSART(10);
if (ConfrontaDataX(2,(const rom char*)"OK")!=0){
ErroreGsm =1;
}

//******************* imposta gli sms come testo
AzzeraDataX(13,10);
putrsUSART((const far rom char *)"AT+CMGF=1\r\n");
AttendiRispostaUSART(10);
if (ConfrontaDataX(2,(const rom char*)"OK")!=0){
ErroreGsm =1;
}


// ******************CANCELLA SMS N 1 - 10
for (r=1 ;r< 10;r++){
AzzeraDataX(13,10);
NumSms = (r+48);
putrsUSART((const far rom char *)"AT+CMGD=");
WriteUSART (NumSms);
putrsUSART((const far rom char *)"\r\n");
AttendiRispostaUSART(10);
if (ConfrontaDataX(2,(const rom char*)"OK")!=0){
//ComponiStringaGsm(2,2);
//if (Confronta(Stringa,(const rom char*)"OK")!=0){
ErroreGsm =1;
}
}
if (ErroreGsm == 0){
Beep (100,1);
ClearLCD();
WriteStringLCD("IMPOSTAZIONI GSM");
Line2LCD();
WriteStringLCD("ESEGUITE.  OK  ");
delay_ms (2000);
ClearLCD();
WriteStringLCD("LIVELLO SEGNALE");
Line2LCD();
WriteStringLCD("GSM (MAX30) = ");
//delay_ms (8000);
AzzeraDataX(13,10);
putrsUSART((far rom char *)"AT+CSQ\r\n");//ATE0: Eco dei comandi disabilitato
AttendiRispostaUSART(10);
Segnale=0;
if (DataX[9]==','){
Segnale = (DataX[8]-48);
}else{
Segnale = (DataX[8]-48)*10;
Segnale = Segnale + (DataX[9]-48);
}
WriteIntLCD(Segnale,2);
delay_ms(2000);
ClearLCD();
WriteStringLCD("RICHIEDO GESTORE");
Line2LCD();
AzzeraDataX(13,10);
putrsUSART((far rom char *)"AT+COPS\=\?\r\n");//COPS : RICHIEDE NOME GESTORE
AttendiRispostaUSART(250);
TipoGestore =0 ;
if (ConfrontaDataX(13,(const rom char*)"TELECOM")!=1){
TipoGestore = 1 ;
WriteStringLCD("TIM");
}
if (ConfrontaDataX(13,(const rom char*)"vodafone")!=1){
TipoGestore = 2 ;
WriteStringLCD("VODAFONE");
}
if (TipoGestore==0){
WriteStringLCD("NON RICONOSCIUTO");
}


delay_ms(2000);


}else{
Beep (100,3);
ClearLCD();
WriteStringLCD("IMPOSTAZIONI GSM");
Line2LCD();
WriteStringLCD("NON CORRETTE !  ");
delay_ms (2000);
}

}




//*************************************************************
//            GESTIONE SMS
//*************************************************************
unsigned char GestioneSMS (void){
unsigned char PassSmsRicevuto[4];
unsigned char CodiceSMS[3];
unsigned char OraSmsOk =0;
unsigned char CodiceOk =0;
unsigned char FlagChiamataDaGestore =0;
unsigned char x8;
LuceLCD=1;
ClearLCD();
HomeLCD();
WriteStringLCD("SMS IN ARRIVO");
delay_ms (100);
NumSms = DataX[14];
AzzeraDataX('K',13);
// invia comando per leggere l'sms ricevuto
putrsUSART((const far rom char *)"AT+CMGR=");
WriteUSART (NumSms);
putrsUSART((far rom char*)"\r\n");//LEGGE SMS SINGOLO
AttendiRispostaUSART(20);

r= 0;
a=0;


while (r<3){   // ricerca la terza "  per vedere dove  il numero chiamante
if (DataX[a]=='"'){
r++;
}
a++;
}

if (!(DataX[a]== '+')){  // VERIFICA SE E' UN SMS INVIATO DAL GESTORE
FlagChiamataDaGestore=1;
}else{
a=(a+3);
for (r=0;r<10;r++){  
NumChiamante[r]= DataX[a+r];
}
}

// *********************************************RILEVA NUMERO CHIAMANTE

// ****************************************CANCELLA SMS DA MEMORIA SIM
putrsUSART((const far rom char *)"AT+CMGD=");
WriteUSART (NumSms);
putrsUSART((const far rom char *)"\r\n");
delay_ms(100);

for (r=5;r<100;r++){
if (DataX[r]== 10 & DataX[r-1]==13){
a=(r+1);  // a = inizio testo sms
r=100;
}
}
if (FlagChiamataDaGestore==1){
for (x8=0;x8<160;x8++){
if ((a+x8)<100){
TestoSms[x8]= DataX[a+x8];
}else{
TestoSms [x8]= DataX0[(a+x8)-100];
}
}
InviaSms (98,1);
for (x8=0;x8<160;x8++){
DataX0[x8]=' ';
}
return(0);
}
FlagPassSms =1;
// *********************************COMPONI E CONTROLLA PASSWORD SMS
for (r=0;r<4;r++){
PassSmsRicevuto[r]= DataX[r+a];
//******************************* TRASFORMA CARATTERI IN MAIUSCOLO
if ((PassSmsRicevuto[r]> 96)& (PassSmsRicevuto[r]<123)){
PassSmsRicevuto[r]= PassSmsRicevuto[r]-32;
}
if (PassSms[r]!= PassSmsRicevuto[r]){
FlagPassSms =0;
}
}

Line2LCD();
WriteStringLCD("PASSWORD ");
if (FlagPassSms==1){
WriteStringLCD("OK");
a=a+5;
for (r=0;r<2;r++){
if ((DataX[a+r]>96) & (DataX[a+r]<123)){
DataX[a+r]= DataX[a+r]-32;
}
CodiceSMS[r]=DataX[a+r];
}
CodiceOk=0;
//****************************************** RICHIESTA SMS CON ORARIO CAMPANILE
if ((CodiceSMS[0]== 'R')& (CodiceSMS[1]=='C')){ //RC = Richiesta Credito
CodiceOk =1;
FlagRichiestaCredito =1;
InviaSms(99,2);
return(0);
}
//****************************************** RICHIESTA SMS CON ORARIO CAMPANILE
if ((CodiceSMS[0]== 'R')& (CodiceSMS[1]=='O')){ //RO = Richiesta Orario
CodiceOk =1;
InviaSms(6,0);
}
//************************************************// SMS  CAMBIO ORARIO
if ((CodiceSMS[0]== 'C')& (CodiceSMS[1]=='O')){ // CO = Cambio Orario
//CONTROLLA DATI
CodiceOk =1;
a=a+3; // inizio ora
OraSmsOk =1;
for (r=0;r<6;r++){
// TRASFORMA DA CARATTERE ASCII IN DECIMALE
DataX[a+r]= DataX[a+r]-48;
if ((DataX[a]<0)|(DataX[a]>9)){ // controlla se sono numeri ok
OraSmsOk=0;
}
}
//|
if (DataX[a]>2){ // controlla decine ore
OraSmsOk=0;
}
if ((DataX[a]==2)&(DataX[a+1]>3)){ // controlla unita ore
OraSmsOk=0;
}
if (DataX[a+2] > 6){// controlla unita minuti
OraSmsOk=0;
}
if (DataX[a+4] > 6){// controlla unita secondi
OraSmsOk=0;
}
if (OraSmsOk==1){
set_hours_RTCC ((DataX[a] << 4)+ DataX[a+1]);
set_minutes_RTCC ((DataX[a+2] << 4)+ DataX[a+3]);
set_seconds_RTCC ((DataX[a+4] << 4)+ DataX[a+5]);
InviaSms(6,0);// invia orario campanile

if (FlagPuntoZero == 1){
Vai_a_punto_zero();
if (Errore[6]| Errore[3] | Errore[4]){
//TotaleSecondiLancette = TotaleSecondi ;
InviaSms(13,0);
}else{
TotaleSecondiLancette = 0;
}
}



}else{
InviaSms(3,0);// orario non corretto
}
}
//*********************** SMS PER INSERIRE SUONERIA  "MORTO" CON TIMER
if ((CodiceSMS[0]== 'S')&((CodiceSMS[1]=='M')|(CodiceSMS[1]=='F'))){ // SM = Suoneria "MORTO"
CodiceOk =1;
TipoSuonoMorto =CodiceSMS[1];
a=a+3; // inizio ora
OraSmsOk =1;
for (r=0;r<6;r++){
// TRASFORMA DA CARATTERE ASCII IN DECIMALE
DataX[a+r]= DataX[a+r]-48;
if ((DataX[a]<0)|(DataX[a]>9)){ // controlla se sono numeri ok
OraSmsOk=0;
}
}
//|
if (DataX[a]>2){ // controlla decine ore
OraSmsOk=0;
}
if ((DataX[a]==2)&(DataX[a+1]>3)){ // controlla unita ore
OraSmsOk=0;
}
if (DataX[a+2] > 6){// controlla decine minuti
OraSmsOk=0;
}
//if (DataX[a+4] > 6){// controlla decine secondi...non utilizzato
//OraSmsOk=0;
//}
if (OraSmsOk==1){
Suonerie[0][0]=(DataX[a]*10)+DataX[a+1];  //decine ore
Suonerie[0][1]=(DataX[a+2]*10)+DataX[a+3];//unita ore
Suonerie[0][2]=3;//suoneria abbinata
Suonerie[0][3]=3;// suona ogni giorno
Suonerie[0][4]=1;// suoneria abilitata

for (r=0;r<4;r++){
// TRASFORMA DA CARATTERE ASCII IN DECIMALE
Orario[r]= DataX[a+r]+48;
}


if (TipoSuonoMorto=='M'){
InviaSms(11,0);// maschio
}else{
InviaSms(12,0);//  femmina
}
}else{
InviaSms(3,0);//orario non corretto
//rospo
}
}
//*********************** SMS PER ABILITARE MELODIA CON SQUILLO
if ((CodiceSMS[0]== 'M')& (CodiceSMS[1]=='E')){ // ME = MElodia con Squillo
CodiceOk =1;
if (FlagMelodiaSquillo > 0){ // invia sms in quanto suoneria gia' attiva
InviaSms (9,0);
}else{
FlagMelodiaSquillo = (DataX[a+3]-48);
if (!((FlagMelodiaSquillo >0) & (FlagMelodiaSquillo < 10))){
InviaSms (7,0); // numero suoneria non corretto
FlagMelodiaSquillo =0;
}else{
OreScadSquillo = Ore +3;
if (OreScadSquillo > 24){
OreScadSquillo = OreScadSquillo -24;
}
for (r=0;r<10;r++){  
NumAbilitatoSquillo[r]= NumChiamante[r];
}
InviaSms (8,0);
}
}
}
//*********************** SMS PER ANNULLARE COMANDI SUONERIE INVIATI
if ((CodiceSMS[0]== 'A')& (CodiceSMS[1]=='S')){ // AS = Annulla  Suonerie
CodiceOk =1;
FlagSettimanaPasquale = 0 ;
FlagDisabilitaCampane = 0;
FlagMelodiaSquillo =0;
Suonerie[0][4]=0;// suoneria disabilitata
InviaSms(10,0);
}

//*********************** SMS PER DISABILITARE LE CAMPANE
if ((CodiceSMS[0]== 'D')& (CodiceSMS[1]=='C')){ // DC = Disabilita Campane  Suonerie
CodiceOk =1;
if (FlagDisabilitaCampane == 0){
FlagDisabilitaCampane = 1;
} else {
FlagDisabilitaCampane = 0;
}
InviaSms(17,0);
}

//*********************** SMS PER SINCRONIZZARE LANCETTE
if ((CodiceSMS[0]== 'S')& (CodiceSMS[1]=='L')){ // SL = Sincronizza Lancette
CodiceOk = 1;
Vai_a_punto_zero();
if(Errore[6]=00 & Errore[3]==0 & Errore[4]==0){
TotaleSecondiLancette = 0;
}

}

//*********************** SMS PER ANNULLARE/ATTIVARE L'INVIO DI SMS CONTROLLO LANCETTE
if ((CodiceSMS[0]== 'C')& (CodiceSMS[1]=='L')){ // CL = Controllo Lancette
CodiceOk = 1;
if (FlagSmsLancette == 0){
writeI2C_EEPROM (0xA0, 1007, 0x01);
} else {
writeI2C_EEPROM (0xA0, 1007, 0x00);
}
delay_ms (10);
readI2C_EEPROM (0xA0, 1007, &FlagSmsLancette);
delay_ms (10);
InviaSms(15,0);
}
//*********************** SMS PER SINCRONIZZARE LANCETTE
if ((CodiceSMS[0]== 'A')& (CodiceSMS[1]=='E')){ // AE = Azzera Errori
CodiceOk = 1;
for (x8=0;x8<10;x8++){
Errore[x8]=0;
}
InviaSms(14,0);
}

//*********************** SMS PER SETTIMANA PASQUALE
if ((CodiceSMS[0]== 'S')& (CodiceSMS[1]=='P')){ // SP = Settimana Pasquale
CodiceOk = 1;
if (FlagSettimanaPasquale == 0){
FlagSettimanaPasquale = 1;
} else {
FlagSettimanaPasquale = 0;
FlagDisabilitaCampane = 0;
}
InviaSms (16,0);
}


if (CodiceOk==0){
InviaSms(5,0);
}

}else{
WriteStringLCD("KO");
InviaSms(4,0);
}
ClearLCD();
delay_ms(2000);
AzzeraDataX(13,10);
FlagRicSMS = 0;
}




//*************************************************************************
//   INVIA SMS
//**************************************
unsigned char InviaSms (unsigned char TipoSms,unsigned char NumDaChiamare){
// NumDaChiamare = 0   risposta a sms
// NumDaChiamare = 1 invio sms tecnico
// NumDaChiamare = 2 invio sms a TipoGestore 1=(TIM=40916) 2=(VODAFONE = 404)
	unsigned char Valore;
unsigned char x7=0;

ClearLCD();
LuceLCD =1;




switch (NumDaChiamare){
case 0:         // compone numero di chi ha mandato l'ultimo sms
WriteStringLCD("INVIO SMS ");
WriteIntLCD(TipoSms,2);
delay_ms(800);
putrsUSART((const far rom char *)"AT+CMGW=\"\+39");
delay_ms (100);
for (r=0;r<10;r++){
WriteUSART (NumChiamante[r]);
delay_ms (10);
}
break;
case 1:                  // compone numero impostato per sms tecnico
WriteStringLCD("INVIO SMS ");
WriteIntLCD(TipoSms,2);
delay_ms(800);
putrsUSART((const far rom char *)"AT+CMGW=\"\+39");
delay_ms (100);
for (r=0;r<10;r++){
WriteUSART (NumSmsTecnici[r]);
delay_ms (10);
}
break;
case 2:
WriteStringLCD("INVIO SMS PER");
Line2LCD();
WriteStringLCD("RIC. CREDITO");
delay_ms(800);
switch (TipoGestore){
case 1:
putrsUSART((const far rom char *)"AT+CMGW=\"40916");
delay_ms (100);
break;
case 2: // invia chiamata al 404 anziche inviare sms
putrsUSART((const far rom char *)"ATD\+39404\r\n");
delay_ms (100);
return(0);
}
break;
}

delay_ms (100);
putrsUSART (( const far rom char*)"\"\r\n");
delay_ms(250);
switch (TipoSms){
case 1:
putrsUSART((const far rom char *)"messaggio ricevuto");
break;
case 2:
putrsUSART((const far rom char *)"ORARIO CAMBIATO");
break;
case 3:
putrsUSART((const far rom char *)"ORARIO NON CORRETTO");
break;
case 4:
putrsUSART((const far rom char *)"PASSWORD ERRATA");
break;
case 5:
putrsUSART((const far rom char *)"CODICE SCONOSCIUTO");
break;
case 6: // INVIA ORARIO CAMPANILE


	Valore = get_hours_RTCC();	
		// with +48 I convert the number in ASCII number
	Orario[1] = (Valore & 0b00001111)+48; 
	Orario[0] = (Valore >> 4)+48;
	Orario[2] = ':';
	
	Valore = get_minutes_RTCC();	
	Orario[4] = (Valore & 0b00001111)+48;
	Orario[3] = (Valore >> 4)+48;
	Orario[5] = ':';

	Valore = get_seconds_RTCC();	
	Orario[7] = (Valore & 0b00001111)+48;
	Orario[6] = (Valore >> 4)+48;
	
	Orario[8] = '\0';
		

putrsUSART((const far rom char *)"ORARIO CAMPANILE = \r\n");
for (r=0;r<9;r++){
WriteUSART (Orario[r]);
delay_ms (10);
}
break;
case 7:
putrsUSART((const far rom char *)"NUMERO SUONERIA NON CORRETTO");
break;
case 8:
putrsUSART((const far rom char *)"SUONERIA ");
WriteUSART ((FlagMelodiaSquillo+ 48));
putrsUSART((const far rom char *)"\r\n\ ABILITATA CON SQUILLO");
break;
case 9:
putrsUSART((const far rom char *)"SUONERIA ");
WriteUSART ((FlagMelodiaSquillo+ 48));
putrsUSART((const far rom char *)"\r\n\ GIA' ABILITATA");
break;
case 10:
putrsUSART((const far rom char *)"ANNULLATO COMANDI SUONERIA ");
break;
case 11:
putrsUSART((const far rom char *)"SUONO MORTO MASCHIO ATTIVATO\r\n");
for (r=0;r<4;r++){
WriteUSART (Orario[r]);
delay_ms (10);
}
break;
case 12:
putrsUSART((const far rom char *)"SUONO MORTO FEMMINA ATTIVATO\r\n");
for (r=0;r<4;r++){
WriteUSART (Orario[r]);
delay_ms (10);
}

break;
case 13:
putrsUSART((const far rom char *)"PUNTO ZERO NON TROVATO\r\n");

break;
case 14:
putrsUSART((const far rom char *)"ERRORI AZZERATI\r\n");
break;
case 15:
putrsUSART((const far rom char *)"INVIO SMS CONTROLLO \r\n");
delay_ms (10);
putrsUSART((const far rom char *)"LANCETTE: ");
if (FlagSmsLancette ==1 ){
putrsUSART((const far rom char *)"ATTIVATO\r\n");
} else {
putrsUSART((const far rom char *)"DISATTIVATO\r\n");
}
break;

case 16:
putrsUSART((const far rom char *)"SETTIMANA PASQUALE \r\n");
delay_ms (10);
if (FlagSettimanaPasquale ==1 ){
putrsUSART((const far rom char *)"ATTIVATA\r\n");
} else {
putrsUSART((const far rom char *)"DISATTIVATA\r\n");
}
break;

case 17:
putrsUSART((const far rom char *)"CAMPANE ");
delay_ms (10);
if (FlagDisabilitaCampane ==0 ){
putrsUSART((const far rom char *)"ATTIVATE\r\n");
} else {
putrsUSART((const far rom char *)"DISATTIVATE\r\n");
}
break;
//*************INVIO MESSAGGI TECNICI
case 20:
putrsUSART((const far rom char *)"MANCA ALIMENTAZIONE 230V.");
break;
case 21:
putrsUSART((const far rom char *)"BATTERIA QUASI SCARICA");
break;
case 22:
putrsUSART((const far rom char *)"BATTERIA SCARICA");
break;
case 23:
putrsUSART((const far rom char *)"PROX MINUTI NON TROVATO");
break;
case 24:
putrsUSART((const far rom char *)"PROX ORE NON TROVATO");
break;
case 25:
putrsUSART((const far rom char *)"POSIZIONE LANCETTE ERRATA");
Valore = get_hours_RTCC();	
	
	// with +48 I convert the number in ASCII number
	Orario[1] = (Valore & 0b00001111)+48; 
	Orario[0] = (Valore >> 4)+48;
	Orario[2] = ':';
	
	Valore = get_minutes_RTCC();	
	Orario[4] = (Valore & 0b00001111)+48;
	Orario[3] = (Valore >> 4)+48;
	Orario[5] = ':';

	Valore = get_seconds_RTCC();	
	Orario[7] = (Valore & 0b00001111)+48;
	Orario[6] = (Valore >> 4)+48;
	
	Orario[8] = '\0';
		

putrsUSART((const far rom char *)" ORARIO DIGITALE = \r\n");
for (r=0;r<9;r++){
WriteUSART (Orario[r]);
delay_ms (10);
}
break;
case 26:
putrsUSART((const far rom char *)"PROX ORE NON TROVATO");// ?????????
break;
case 27 : //  PROVA :INVIA SMS DELL'ORA DIGITALE QUANDO LA LANCETTA MINUTI ARRIVA SUL PROSSIMITY ALLE 14
putrsUSART((const far rom char *)"LANCETTA MINUTI ARRIVATA SU PROSSIMITY \r\n");
Valore = get_hours_RTCC();	
	
	// with +48 I convert the number in ASCII number
	Orario[1] = (Valore & 0b00001111)+48; 
	Orario[0] = (Valore >> 4)+48;
	Orario[2] = ':';
	
	Valore = get_minutes_RTCC();	
	Orario[4] = (Valore & 0b00001111)+48;
	Orario[3] = (Valore >> 4)+48;
	Orario[5] = ':';

	Valore = get_seconds_RTCC();	
	Orario[7] = (Valore & 0b00001111)+48;
	Orario[6] = (Valore >> 4)+48;
	
	Orario[8] = '\0';
		

putrsUSART((const far rom char *)"ALLE ORE ");
for (r=0;r<9;r++){
WriteUSART (Orario[r]);
delay_ms (10);
}
break ;
case 28:
putrsUSART((const far rom char *)"EFFETTUATO CORREZIONE \r\n");
delay_ms (10);
putrsUSART((const far rom char *)"AUTOMATICA POSIZIONE LANCETTE \r\n");
delay_ms (10);
if (PassiCorrRitLanc>0){
putrsUSART((const far rom char *)"RITARDATO \r\n");
}else{
putrsUSART((const far rom char *)"AVANZAMENTO \r\n");
}
Valore = get_hours_RTCC();	
	
	// with +48 I convert the number in ASCII number
	Orario[1] = (Valore & 0b00001111)+48; 
	Orario[0] = (Valore >> 4)+48;
	Orario[2] = ':';
	
	Valore = get_minutes_RTCC();	
	Orario[4] = (Valore & 0b00001111)+48;
	Orario[3] = (Valore >> 4)+48;
	Orario[5] = ':';

	Valore = get_seconds_RTCC();	
	Orario[7] = (Valore & 0b00001111)+48;
	Orario[6] = (Valore >> 4)+48;
	
	Orario[8] = '\0';
		
putrsUSART((const far rom char *)"ALLE ORE ");
for (r=0;r<9;r++){
WriteUSART (Orario[r]);
delay_ms (10);
}
break;

case 98:
for (x7=0;x7<160;x7++){
WriteUSART (TestoSms[x7]);
delay_ms (15);
}

break;

case 99:
//putrsUSART((const far rom char *)" ");
putrsUSART((const far rom char *)"CREDITO");
break;
}

delay_ms(250);

AzzeraDataX(13,10);
WriteUSART (0x1A);

AttendiRispostaUSART(20);
NumSms = DataX[9];


// INVIA SMS N NumSms da modulo Gsm
//putrsUSART((const far rom char *)"AT+CMSS=6\r\n");// invia messaggio 6
if (FlagInvioSMS == 1){
putrsUSART((const far rom char *)"AT+CMSS=");
WriteUSART (NumSms);
putrsUSART((far rom char*)"\r\n");
}
// CANCELLA SMS DA MEMORIA SIM
putrsUSART((const far rom char *)"AT+CMGD=");
WriteUSART (NumSms);
putrsUSART((const far rom char *)"\r\n");
delay_ms(500);
//putrsUSART((const far rom char *)"CREDITO");

}
//*************************************************************
//            GESTIONE SQUILLI
//*************************************************************
unsigned char GestioneSquilli (void){
unsigned char NumArrivoSquillo[10];
for (r=0;r<10;r++){  // rileva numero chiamante
if (NumAbilitatoSquillo[r] != DataX[13+r]){
putrsUSART((far rom char *)"ATH\r\n");//ATE0: Eco dei comandi disabilitato
delay_ms(100);
AzzeraDataX (13,10); 
FlagBufferOn== 0;
return(0);
}
}
putrsUSART((far rom char *)"ATH\r\n");//ATE0: Eco dei comandi disabilitato
delay_ms(100);
AzzeraDataX (13,10); 
FlagBufferOn== 0;
if (FlagSuonSquilloAttiva == 0){
if (FlagMelodiaSquillo >0){
EseguiSuoneriaSquillo();
}
}else{
FlagSuonSquilloAttiva = 2;
}


}


//*************************************************************
//            COMPONI STRINGA DA DataX
//*************************************************************
unsigned char ComponiStringaGsm (unsigned char InizioDataX, unsigned char LungStr){
unsigned char x3;
for (x3=0;x3<(LungStr);x3++){
Stringa[x3]=DataX[InizioDataX+x3];
}
Stringa[x3]='\0';
}
//*************************************************************
//            CONFRONTA STRINGA CON STRINGA
//*************************************************************
int Confronta(char* str1, const rom char* str2){
int i=0;
char g[]="kukko";
char h[]="hh";
for (i=0;i<4;i++){
g[i]=str1[i];
}

for (i=0;i<4;i++){
h[i]=str2[i];
}
i=0;
while(str1[i] != \0&&
str2[i] != \0 &&
str1[i]==str2[i])
i++;
return str1[i] - str2[i];
}

//*************************************************************
//            CONFRONTA STRINGA DA DataX
//*************************************************************
unsigned char ConfrontaDataX(char Inizio,const rom char* str3){
unsigned char x5;
unsigned charrisultato =0;
x5=0;
while(str3[x5] != \0){
if(DataX[x5+Inizio]!=str3[x5]){
return (1);
}
x5++;
}
return (0);
}
//*************************************************************
//            AZZERA BUFFER DATAX INTERRUPT
//*************************************************************
unsigned char AzzeraDataX (unsigned char UltimoCar,unsigned char CarAttuale){

for (x=0;x<100;x++){
DataX[x] = 0;
}
x=0;
CarOld = UltimoCar; // Penultimo carattere da confr. per fermare lettura Buffer usart
CarOk = CarAttuale; // Ultimo carattere da confr. per fermare lettura usart
FlagBufferOn = 0;
TimOut =0;
}


//**********************************FINE
